/*
 * Copyright (c) 2007-2011 The Khronos Group Inc.
 * Copyright (C) 2010-2011 Linaro Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Authored-by: Jammy Zhou <jammy.zhou@linaro.org>
 */

#ifndef __GLEXT_PROXY_H
#define __GLEXT_PROXY_H

#ifdef __cplusplus
extern "C" {
#endif

/* ------------------------------------------------------------------------
 * OpenGL ES2.0 extensions support
 * -----------------------------------------------------------------------*/

/* ------------------------------------------------------------------------
 * tokens defined in <GLES2/gl2ext.h>
 * -----------------------------------------------------------------------*/

/* GL_OES_compressed_ETC1_RGB8_texture */
#define GL_ETC1_RGB8_OES                                        0x8D64

/* GL_OES_compressed_paletted_texture */
#define GL_PALETTE4_RGB8_OES                                    0x8B90
#define GL_PALETTE4_RGBA8_OES                                   0x8B91
#define GL_PALETTE4_R5_G6_B5_OES                                0x8B92
#define GL_PALETTE4_RGBA4_OES                                   0x8B93
#define GL_PALETTE4_RGB5_A1_OES                                 0x8B94
#define GL_PALETTE8_RGB8_OES                                    0x8B95
#define GL_PALETTE8_RGBA8_OES                                   0x8B96
#define GL_PALETTE8_R5_G6_B5_OES                                0x8B97
#define GL_PALETTE8_RGBA4_OES                                   0x8B98
#define GL_PALETTE8_RGB5_A1_OES                                 0x8B99

/* GL_OES_depth24 */
#define GL_DEPTH_COMPONENT24_OES                                0x81A6

/* GL_OES_depth32 */
#define GL_DEPTH_COMPONENT32_OES                                0x81A7

/* GL_OES_EGL_image */
typedef void* GLeglImageOES;

/* GL_OES_element_index_uint */
#define GL_UNSIGNED_INT                                         0x1405

/* GL_OES_get_program_binary */
#define GL_PROGRAM_BINARY_LENGTH_OES                            0x8741
#define GL_NUM_PROGRAM_BINARY_FORMATS_OES                       0x87FE
#define GL_PROGRAM_BINARY_FORMATS_OES                           0x87FF

/* GL_OES_mapbuffer */
#define GL_WRITE_ONLY_OES                                       0x88B9
#define GL_BUFFER_ACCESS_OES                                    0x88BB
#define GL_BUFFER_MAPPED_OES                                    0x88BC
#define GL_BUFFER_MAP_POINTER_OES                               0x88BD

/* GL_OES_packed_depth_stencil */
#define GL_DEPTH_STENCIL_OES                                    0x84F9
#define GL_UNSIGNED_INT_24_8_OES                                0x84FA
#define GL_DEPTH24_STENCIL8_OES                                 0x88F0

/* GL_OES_rgb8_rgba8 */
#define GL_RGB8_OES                                             0x8051
#define GL_RGBA8_OES                                            0x8058

/* GL_OES_standard_derivatives */
#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT_OES                  0x8B8B

/* GL_OES_stencil1 */
#define GL_STENCIL_INDEX1_OES                                   0x8D46

/* GL_OES_stencil4 */
#define GL_STENCIL_INDEX4_OES                                   0x8D47

/* GL_OES_texture_3D */
#define GL_TEXTURE_WRAP_R_OES                                   0x8072
#define GL_TEXTURE_3D_OES                                       0x806F
#define GL_TEXTURE_BINDING_3D_OES                               0x806A
#define GL_MAX_3D_TEXTURE_SIZE_OES                              0x8073
#define GL_SAMPLER_3D_OES                                       0x8B5F
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES        0x8CD4

/* GL_OES_texture_half_float */
#define GL_HALF_FLOAT_OES                                       0x8D61

/* GL_OES_vertex_array_object */
#define GL_VERTEX_ARRAY_BINDING_OES                             0x85B5

/* GL_OES_vertex_type_10_10_10_2 */
#define GL_UNSIGNED_INT_10_10_10_2_OES                          0x8DF6
#define GL_INT_10_10_10_2_OES                                   0x8DF7

/* GL_AMD_compressed_3DC_texture */
#define GL_3DC_X_AMD                                            0x87F9
#define GL_3DC_XY_AMD                                           0x87FA

/* GL_AMD_compressed_ATC_texture */
#define GL_ATC_RGB_AMD                                          0x8C92
#define GL_ATC_RGBA_EXPLICIT_ALPHA_AMD                          0x8C93
#define GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD                      0x87EE

/* GL_AMD_performance_monitor */
#define GL_COUNTER_TYPE_AMD                                     0x8BC0
#define GL_COUNTER_RANGE_AMD                                    0x8BC1
#define GL_UNSIGNED_INT64_AMD                                   0x8BC2
#define GL_PERCENTAGE_AMD                                       0x8BC3
#define GL_PERFMON_RESULT_AVAILABLE_AMD                         0x8BC4
#define GL_PERFMON_RESULT_SIZE_AMD                              0x8BC5
#define GL_PERFMON_RESULT_AMD                                   0x8BC6

/* GL_AMD_program_binary_Z400 */
#define GL_Z400_BINARY_AMD                                      0x8740

/* GL_EXT_blend_minmax */
#define GL_MIN_EXT                                              0x8007
#define GL_MAX_EXT                                              0x8008

/* GL_EXT_discard_framebuffer */
#define GL_COLOR_EXT                                            0x1800
#define GL_DEPTH_EXT                                            0x1801
#define GL_STENCIL_EXT                                          0x1802

/* GL_EXT_read_format_bgra */
#define GL_BGRA_EXT                                             0x80E1
#define GL_UNSIGNED_SHORT_4_4_4_4_REV_EXT                       0x8365
#define GL_UNSIGNED_SHORT_1_5_5_5_REV_EXT                       0x8366

/* GL_EXT_texture_filter_anisotropic */
#define GL_TEXTURE_MAX_ANISOTROPY_EXT                           0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT                       0x84FF

/* GL_EXT_texture_format_BGRA8888 */
#define GL_BGRA_EXT                                             0x80E1

/* GL_EXT_texture_type_2_10_10_10_REV */
#define GL_UNSIGNED_INT_2_10_10_10_REV_EXT                      0x8368

/* GL_EXT_texture_compression_dxt1 */
#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT                         0x83F0
#define GL_COMPRESSED_RGBA_S3TC_DXT1_EXT                        0x83F1

/* GL_IMG_program_binary */
#define GL_SGX_PROGRAM_BINARY_IMG                               0x9130

/* GL_IMG_read_format */
#define GL_BGRA_IMG                                             0x80E1
#define GL_UNSIGNED_SHORT_4_4_4_4_REV_IMG                       0x8365

/* GL_IMG_shader_binary */
#define GL_SGX_BINARY_IMG                                       0x8C0A

/* GL_IMG_texture_compression_pvrtc */
#define GL_COMPRESSED_RGB_PVRTC_4BPPV1_IMG                      0x8C00
#define GL_COMPRESSED_RGB_PVRTC_2BPPV1_IMG                      0x8C01
#define GL_COMPRESSED_RGBA_PVRTC_4BPPV1_IMG                     0x8C02
#define GL_COMPRESSED_RGBA_PVRTC_2BPPV1_IMG                     0x8C03

/* GL_IMG_multisampled_render_to_texture */
#define GL_RENDERBUFFER_SAMPLES_IMG                             0x9133
#define GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_IMG               0x9134
#define GL_MAX_SAMPLES_IMG                                      0x9135
#define GL_TEXTURE_SAMPLES_IMG                                  0x9136

/* GL_NV_fence */
#define GL_ALL_COMPLETED_NV                                     0x84F2
#define GL_FENCE_STATUS_NV                                      0x84F3
#define GL_FENCE_CONDITION_NV                                   0x84F4

/* GL_NV_coverage_sample */
#define GL_COVERAGE_COMPONENT_NV                                0x8ED0
#define GL_COVERAGE_COMPONENT4_NV                               0x8ED1
#define GL_COVERAGE_ATTACHMENT_NV                               0x8ED2
#define GL_COVERAGE_BUFFERS_NV                                  0x8ED3
#define GL_COVERAGE_SAMPLES_NV                                  0x8ED4
#define GL_COVERAGE_ALL_FRAGMENTS_NV                            0x8ED5
#define GL_COVERAGE_EDGE_FRAGMENTS_NV                           0x8ED6
#define GL_COVERAGE_AUTOMATIC_NV                                0x8ED7
#define GL_COVERAGE_BUFFER_BIT_NV                               0x8000

/* GL_NV_depth_nonlinear */
#define GL_DEPTH_COMPONENT16_NONLINEAR_NV                       0x8E2C

/* GL_QCOM_extended_get */
#define GL_TEXTURE_WIDTH_QCOM                                   0x8BD2
#define GL_TEXTURE_HEIGHT_QCOM                                  0x8BD3
#define GL_TEXTURE_DEPTH_QCOM                                   0x8BD4
#define GL_TEXTURE_INTERNAL_FORMAT_QCOM                         0x8BD5
#define GL_TEXTURE_FORMAT_QCOM                                  0x8BD6
#define GL_TEXTURE_TYPE_QCOM                                    0x8BD7
#define GL_TEXTURE_IMAGE_VALID_QCOM                             0x8BD8
#define GL_TEXTURE_NUM_LEVELS_QCOM                              0x8BD9
#define GL_TEXTURE_TARGET_QCOM                                  0x8BDA
#define GL_TEXTURE_OBJECT_VALID_QCOM                            0x8BDB
#define GL_STATE_RESTORE                                        0x8BDC

/* GL_QCOM_perfmon_global_mode */
#define GL_PERFMON_GLOBAL_MODE_QCOM                             0x8FA0

/* GL_QCOM_writeonly_rendering */
#define GL_WRITEONLY_RENDERING_QCOM                             0x8823

/* GL_QCOM_tiled_rendering */
#define GL_COLOR_BUFFER_BIT0_QCOM                               0x00000001
#define GL_COLOR_BUFFER_BIT1_QCOM                               0x00000002
#define GL_COLOR_BUFFER_BIT2_QCOM                               0x00000004
#define GL_COLOR_BUFFER_BIT3_QCOM                               0x00000008
#define GL_COLOR_BUFFER_BIT4_QCOM                               0x00000010
#define GL_COLOR_BUFFER_BIT5_QCOM                               0x00000020
#define GL_COLOR_BUFFER_BIT6_QCOM                               0x00000040
#define GL_COLOR_BUFFER_BIT7_QCOM                               0x00000080
#define GL_DEPTH_BUFFER_BIT0_QCOM                               0x00000100
#define GL_DEPTH_BUFFER_BIT1_QCOM                               0x00000200
#define GL_DEPTH_BUFFER_BIT2_QCOM                               0x00000400
#define GL_DEPTH_BUFFER_BIT3_QCOM                               0x00000800
#define GL_DEPTH_BUFFER_BIT4_QCOM                               0x00001000
#define GL_DEPTH_BUFFER_BIT5_QCOM                               0x00002000
#define GL_DEPTH_BUFFER_BIT6_QCOM                               0x00004000
#define GL_DEPTH_BUFFER_BIT7_QCOM                               0x00008000
#define GL_STENCIL_BUFFER_BIT0_QCOM                             0x00010000
#define GL_STENCIL_BUFFER_BIT1_QCOM                             0x00020000
#define GL_STENCIL_BUFFER_BIT2_QCOM                             0x00040000
#define GL_STENCIL_BUFFER_BIT3_QCOM                             0x00080000
#define GL_STENCIL_BUFFER_BIT4_QCOM                             0x00100000
#define GL_STENCIL_BUFFER_BIT5_QCOM                             0x00200000
#define GL_STENCIL_BUFFER_BIT6_QCOM                             0x00400000
#define GL_STENCIL_BUFFER_BIT7_QCOM                             0x00800000
#define GL_MULTISAMPLE_BUFFER_BIT0_QCOM                         0x01000000
#define GL_MULTISAMPLE_BUFFER_BIT1_QCOM                         0x02000000
#define GL_MULTISAMPLE_BUFFER_BIT2_QCOM                         0x04000000
#define GL_MULTISAMPLE_BUFFER_BIT3_QCOM                         0x08000000
#define GL_MULTISAMPLE_BUFFER_BIT4_QCOM                         0x10000000
#define GL_MULTISAMPLE_BUFFER_BIT5_QCOM                         0x20000000
#define GL_MULTISAMPLE_BUFFER_BIT6_QCOM                         0x40000000
#define GL_MULTISAMPLE_BUFFER_BIT7_QCOM                         0x80000000

/* ------------------------------------------------------------------------
 * proxy function types for OES extension APIs
 * ----------------------------------------------------------------------*/

typedef void      GL_APIENTRY 	(*PFNPROXYEGLIMAGETARGETTEXTURE2DOESPROC) (GLenum target, GLeglImageOES image);
typedef void      GL_APIENTRY 	(*PFNPROXYEGLIMAGETARGETRENDERBUFFERSTORAGEOESPROC) (GLenum target, GLeglImageOES image);
typedef void      GL_APIENTRY 	(*PFNPROXYGETPROGRAMBINARYOESPROC) (GLuint program, GLsizei bufSize, GLsizei *length, GLenum *binaryFormat, GLvoid *binary);
typedef void      GL_APIENTRY 	(*PFNPROXYPROGRAMBINARYOESPROC) (GLuint program, GLenum binaryFormat, const GLvoid *binary, GLint length);
typedef void*     GL_APIENTRY 	(*PFNPROXYMAPBUFFEROESPROC) (GLenum target, GLenum access);
typedef GLboolean GL_APIENTRY 	(*PFNPROXYUNMAPBUFFEROESPROC) (GLenum target);
typedef void      GL_APIENTRY 	(*PFNPROXYGETBUFFERPOINTERVOESPROC) (GLenum target, GLenum pname, GLvoid** params);
typedef void      GL_APIENTRY 	(*PFNPROXYTEXIMAGE3DOESPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid* pixels);
typedef void      GL_APIENTRY 	(*PFNPROXYTEXSUBIMAGE3DOESPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid* pixels);
typedef void      GL_APIENTRY 	(*PFNPROXYCOPYTEXSUBIMAGE3DOESPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
typedef void      GL_APIENTRY   (*PFNPROXYCOMPRESSEDTEXIMAGE3DOESPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid* data);
typedef void      GL_APIENTRY 	(*PFNPROXYCOMPRESSEDTEXSUBIMAGE3DOESPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid* data);
typedef void      GL_APIENTRY 	(*PFNPROXYFRAMEBUFFERTEXTURE3DOESPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
typedef void      GL_APIENTRY 	(*PFNPROXYBINDVERTEXARRAYOESPROC) (GLuint array);
typedef void      GL_APIENTRY 	(*PFNPROXYDELETEVERTEXARRAYSOESPROC) (GLsizei n, const GLuint *arrays);
typedef void 	  GL_APIENTRY   (*PFNPROXYGENVERTEXARRAYSOESPROC) (GLsizei n, GLuint *arrays);
typedef GLboolean GL_APIENTRY   (*PFNPROXYISVERTEXARRAYOESPROC) (GLuint array);
typedef void      GL_APIENTRY   (*PFNPROXYGETPERFMONITORGROUPSAMDPROC) (GLint *numGroups, GLsizei groupsSize, GLuint *groups);
typedef void      GL_APIENTRY   (*PFNPROXYGETPERFMONITORCOUNTERSAMDPROC) (GLuint group, GLint *numCounters, GLint *maxActiveCounters, GLsizei counterSize, GLuint *counters);
typedef void      GL_APIENTRY   (*PFNPROXYGETPERFMONITORGROUPSTRINGAMDPROC) (GLuint group, GLsizei bufSize, GLsizei *length, GLchar *groupString);
typedef void      GL_APIENTRY   (*PFNPROXYGETPERFMONITORCOUNTERSTRINGAMDPROC) (GLuint group, GLuint counter, GLsizei bufSize, GLsizei *length, GLchar *counterString);
typedef void      GL_APIENTRY	(*PFNPROXYGETPERFMONITORCOUNTERINFOAMDPROC) (GLuint group, GLuint counter, GLenum pname, GLvoid *data);
typedef void      GL_APIENTRY   (*PFNPROXYGENPERFMONITORSAMDPROC) (GLsizei n, GLuint *monitors);
typedef void      GL_APIENTRY   (*PFNPROXYDELETEPERFMONITORSAMDPROC) (GLsizei n, GLuint *monitors);
typedef void      GL_APIENTRY   (*PFNPROXYSELECTPERFMONITORCOUNTERSAMDPROC) (GLuint monitor, GLboolean enable, GLuint group, GLint numCounters, GLuint *countersList);
typedef void      GL_APIENTRY   (*PFNPROXYBEGINPERFMONITORAMDPROC) (GLuint monitor);
typedef void      GL_APIENTRY	(*PFNPROXYENDPERFMONITORAMDPROC) (GLuint monitor);
typedef void      GL_APIENTRY	(*PFNPROXYGETPERFMONITORCOUNTERDATAAMDPROC) (GLuint monitor, GLenum pname, GLsizei dataSize, GLuint *data, GLint *bytesWritten);
typedef void      GL_APIENTRY	(*PFNPROXYDISCARDFRAMEBUFFEREXTPROC) (GLenum target, GLsizei numAttachments, const GLenum *attachments);
typedef void      GL_APIENTRY	(*PFNPROXYMULTIDRAWARRAYSEXTPROC) (GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
typedef void      GL_APIENTRY	(*PFNPROXYMULTIDRAWELEMENTSEXTPROC) (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount);
typedef void 	  GL_APIENTRY  	(*PFNPROXYRENDERBUFFERSTORAGEMULTISAMPLEIMGPROC) (GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
typedef void      GL_APIENTRY	(*PFNPROXYFRAMEBUFFERTEXTURE2DMULTISAMPLEIMGPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples);
typedef void      GL_APIENTRY	(*PFNPROXYDELETEFENCESNVPROC) (GLsizei n, const GLuint *fences);
typedef void      GL_APIENTRY	(*PFNPROXYGENFENCESNVPROC) (GLsizei n, GLuint *fences);
typedef GLboolean GL_APIENTRY	(*PFNPROXYISFENCENVPROC) (GLuint fence);
typedef GLboolean GL_APIENTRY	(*PFNPROXYTESTFENCENVPROC) (GLuint fence);
typedef void      GL_APIENTRY	(*PFNPROXYGETFENCEIVNVPROC) (GLuint fence, GLenum pname, GLint *params);
typedef void      GL_APIENTRY	(*PFNPROXYFINISHFENCENVPROC) (GLuint fence);
typedef void      GL_APIENTRY	(*PFNPROXYSETFENCENVPROC) (GLuint fence, GLenum condition);
typedef void      GL_APIENTRY	(*PFNPROXYCOVERAGEMASKNVPROC) (GLboolean mask);
typedef void      GL_APIENTRY	(*PFNPROXYCOVERAGEOPERATIONNVPROC) (GLenum operation);
typedef void      GL_APIENTRY	(*PFNPROXYGETDRIVERCONTROLSQCOMPROC) (GLint *num, GLsizei size, GLuint *driverControls);
typedef void      GL_APIENTRY	(*PFNPROXYGETDRIVERCONTROLSTRINGQCOMPROC) (GLuint driverControl, GLsizei bufSize, GLsizei *length, GLchar *driverControlString);
typedef void      GL_APIENTRY	(*PFNPROXYENABLEDRIVERCONTROLQCOMPROC) (GLuint driverControl);
typedef void      GL_APIENTRY	(*PFNPROXYDISABLEDRIVERCONTROLQCOMPROC) (GLuint driverControl);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETTEXTURESQCOMPROC) (GLuint *textures, GLint maxTextures, GLint *numTextures);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETBUFFERSQCOMPROC) (GLuint *buffers, GLint maxBuffers, GLint *numBuffers);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETRENDERBUFFERSQCOMPROC) (GLuint *renderbuffers, GLint maxRenderbuffers, GLint *numRenderbuffers);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETFRAMEBUFFERSQCOMPROC) (GLuint *framebuffers, GLint maxFramebuffers, GLint *numFramebuffers);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETTEXLEVELPARAMETERIVQCOMPROC) (GLuint texture, GLenum face, GLint level, GLenum pname, GLint *params);
typedef void      GL_APIENTRY	(*PFNPROXYEXTTEXOBJECTSTATEOVERRIDEIQCOMPROC) (GLenum target, GLenum pname, GLint param);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETTEXSUBIMAGEQCOMPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLvoid *texels);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETBUFFERPOINTERVQCOMPROC) (GLenum target, GLvoid **params);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETSHADERSQCOMPROC) (GLuint *shaders, GLint maxShaders, GLint *numShaders);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETPROGRAMSQCOMPROC) (GLuint *programs, GLint maxPrograms, GLint *numPrograms);
typedef GLboolean GL_APIENTRY	(*PFNPROXYEXTISPROGRAMBINARYQCOMPROC) (GLuint program);
typedef void      GL_APIENTRY	(*PFNPROXYEXTGETPROGRAMBINARYSOURCEQCOMPROC) (GLuint program, GLenum shadertype, GLchar *source, GLint *length);
typedef void      GL_APIENTRY	(*PFNPROXYSTARTTILINGQCOMPROC) (GLuint x, GLuint y, GLuint width, GLuint height, GLbitfield preserveMask);
typedef void      GL_APIENTRY	(*PFNPROXYENDTILINGQCOMPROC) (GLbitfield preserveMask);

/* ---------------------------------------------------------------------------
 * function rename
 * -------------------------------------------------------------------------*/
#define glEGLImageTargetTexture2DOES		pfnProxyEGLImageTargetTexture2DOES
#define glEGLImageTargetRenderbufferStorageOES	pfnProxyEGLImageTargetRenderbufferStorageOES
#define glGetProgramBinaryOES	 		pfnProxyGetProgramBinaryOES
#define glProgramBinaryOES 			pfnProxyProgramBinaryOES
#define glMapBufferOES 				pfnProxyMapBufferOES
#define glUnmapBufferOES 			pfnProxyUnmapBufferOES
#define glGetBufferPointervOES 			pfnProxyGetBufferPointervOES
#define glTexImage3DOES 			pfnProxyTexImage3DOES
#define glTexSubImage3DOES 			pfnProxyTexSubImage3DOES
#define glCopyTexSubImage3DOES 			pfnProxyCopyTexSubImage3DOES
#define glCompressedTexImage3DOES 		pfnProxyCompressedTexImage3DOES
#define glCompressedTexSubImage3DOES 		pfnProxyCompressedTexSubImage3DOES
#define glFramebufferTexture3DOES 		pfnProxyFramebufferTexture3DOES
#define glBindVertexArrayOES 			pfnProxyBindVertexArrayOES
#define glDeleteVertexArraysOES 		pfnProxyDeleteVertexArraysOES
#define glGenVertexArraysOES 			pfnProxyGenVertexArraysOES
#define glIsVertexArrayOES 			pfnProxyIsVertexArrayOES
#define glGetPerfMonitorGroupsAMD 		pfnProxyGetPerfMonitorGroupsAMD
#define glGetPerfMonitorCountersAMD 		pfnProxyGetPerfMonitorCountersAMD
#define glGetPerfMonitorGroupStringAMD 		pfnProxyGetPerfMonitorGroupStringAMD
#define glGetPerfMonitorCounterStringAMD 	pfnProxyGetPerfMonitorCounterStringAMD
#define glGetPerfMonitorCounterInfoAMD 		pfnProxyGetPerfMonitorCounterInfoAMD
#define glGenPerfMonitorsAMD 			pfnProxyGenPerfMonitorsAMD
#define glDeletePerfMonitorsAMD 		pfnProxyDeletePerfMonitorsAMD
#define glSelectPerfMonitorCountersAMD 		pfnProxySelectPerfMonitorCountersAMD
#define glBeginPerfMonitorAMD 			pfnProxyBeginPerfMonitorAMD
#define glEndPerfMonitorAMD 			pfnProxyEndPerfMonitorAMD
#define glGetPerfMonitorCounterDataAMD 		pfnProxyGetPerfMonitorCounterDataAMD
#define glDiscardFramebufferEXT 		pfnProxyDiscardFramebufferEXT
#define glMultiDrawArraysEXT 			pfnProxyMultiDrawArraysEXT
#define glMultiDrawElementsEXT 			pfnProxyMultiDrawElementsEXT
#define glRenderbufferStorageMultisampleIMG 	pfnProxyRenderbufferStorageMultisampleIMG
#define glFramebufferTexture2DMultisampleIMG 	pfnProxyFramebufferTexture2DMultisampleIMG
#define glDeleteFencesNV 			pfnProxyDeleteFencesNV
#define glGenFencesNV 				pfnProxyGenFencesNV
#define glIsFenceNV 				pfnProxyIsFenceNV
#define glTestFenceNV 				pfnProxyTestFenceNV
#define glGetFenceNV 				pfnProxyGetFenceNV
#define glFinishFenceNV 			pfnProxyFinishFenceNV
#define glSetFenceNV 				pfnProxySetFenceNV
#define glCoverageMaskNV 			pfnProxyCoverageMaskNV
#define glCoverageOperationNV 			pfnProxyCoverageOperationNV
#define glGetDriverControlsQCOM 		pfnProxyGetDriverControlsQCOM
#define glGetDriverControlStringQCOM 		pfnProxyGetDriverControlStringQCOM
#define glEnableDriverControlQCOM 		pfnProxyEnableDriverControlQCOM
#define glDisableDriverControlQCOM 		pfnProxyDisableDriverControlQCOM
#define glExtGetTexturesQCOM 			pfnProxyExtGetTexturesQCOM
#define glExtGetBuffersQCOM 			pfnProxyExtGetBuffersQCOM
#define glExtGetRenderbuffersQCOM 		pfnProxyExtGetRenderbuffersQCOM
#define glExtGetFramebuffersQCOM 		pfnProxyExtGetFramebuffersQCOM
#define glExtGetTexLevelParameterivQCOM 	pfnProxyExtGetTexLevelParameterivQCOM
#define glExtTexObjectStateOverrideQCOM 	pfnProxyExtTexObjectStateOverrideQCOM
#define glExtGetTexSubImageQCOM 		pfnProxyExtGetTexSubImageQCOM
#define glExtGetBufferPointervQCOM 		pfnProxyExtGetBufferPointervQCOM
#define glExtGetShadersQCOM 			pfnProxyExtGetShadersQCOM
#define glExtGetProgramsQCOM 			pfnProxyExtGetProgramsQCOM
#define glExtIsProgramBinaryQCOM 		pfnProxyExtIsProgramBinaryQCOM
#define glExtGetProgramBinarySourceQCOM 	pfnProxyExtGetProgramBinarySourceQCOM
#define glStartTilingQCOM 			pfnProxyStartTilingQCOM
#define glEndTilingQCOM 			pfnProxyEndTilingQCOM

/* ---------------------------------------------------------------------------
 * export proxy functions
 * -------------------------------------------------------------------------*/
extern PFNPROXYEGLIMAGETARGETTEXTURE2DOESPROC pfnProxyEGLImageTargetTexture2DOES;
extern PFNPROXYEGLIMAGETARGETRENDERBUFFERSTORAGEOESPROC pfnProxyEGLImageTargetRenderbufferStorageOES;
extern PFNPROXYGETPROGRAMBINARYOESPROC pfnProxyGetProgramBinaryOES;
extern PFNPROXYPROGRAMBINARYOESPROC pfnProxyProgramBinaryOES;
extern PFNPROXYMAPBUFFEROESPROC pfnProxyMapBufferOES;
extern PFNPROXYUNMAPBUFFEROESPROC pfnProxyUnmapBufferOES;
extern PFNPROXYGETBUFFERPOINTERVOESPROC pfnProxyGetBufferPointervOES;
extern PFNPROXYTEXIMAGE3DOESPROC pfnProxyTexImage3DOES;
extern PFNPROXYTEXSUBIMAGE3DOESPROC pfnProxyTexSubImage3DOES;
extern PFNPROXYCOPYTEXSUBIMAGE3DOESPROC pfnProxyCopyTexSubImage3DOES;
extern PFNPROXYCOMPRESSEDTEXIMAGE3DOESPROC pfnProxyCompressedTexImage3DOES;
extern PFNPROXYCOMPRESSEDTEXSUBIMAGE3DOESPROC pfnProxyCompressedTexSubImage3DOES;
extern PFNPROXYFRAMEBUFFERTEXTURE3DOESPROC pfnProxyFramebufferTexture3DOES;
extern PFNPROXYBINDVERTEXARRAYOESPROC pfnProxyBindVertexArrayOES;
extern PFNPROXYDELETEVERTEXARRAYSOESPROC pfnProxyDeleteVertexArraysOES;
extern PFNPROXYGENVERTEXARRAYSOESPROC pfnProxyGenVertexArraysOES;
extern PFNPROXYISVERTEXARRAYOESPROC pfnProxyIsVertexArrayOES;
extern PFNPROXYGETPERFMONITORGROUPSAMDPROC pfnProxyGetPerfMonitorGroupsAMD;
extern PFNPROXYGETPERFMONITORCOUNTERSAMDPROC pfnProxyGetPerfMonitorCountersAMD;
extern PFNPROXYGETPERFMONITORGROUPSTRINGAMDPROC pfnProxyGetPerfMonitorGroupStringAMD;
extern PFNPROXYGETPERFMONITORCOUNTERSTRINGAMDPROC pfnProxyGetPerfMonitorCounterStringAMD;
extern PFNPROXYGETPERFMONITORCOUNTERINFOAMDPROC pfnProxyGetPerfMonitorCounterInfoAMD;
extern PFNPROXYGENPERFMONITORSAMDPROC pfnProxyGenPerfMonitorsAMD;
extern PFNPROXYDELETEPERFMONITORSAMDPROC pfnProxyDeletePerfMonitorsAMD;
extern PFNPROXYSELECTPERFMONITORCOUNTERSAMDPROC pfnProxySelectPerfMonitorCountersAMD;
extern PFNPROXYBEGINPERFMONITORAMDPROC pfnProxyBeginPerfMonitorAMD;
extern PFNPROXYENDPERFMONITORAMDPROC pfnProxyEndPerfMonitorAMD;
extern PFNPROXYGETPERFMONITORCOUNTERDATAAMDPROC pfnProxyGetPerfMonitorCounterDataAMD;
extern PFNPROXYDISCARDFRAMEBUFFEREXTPROC pfnProxyDiscardFramebufferEXT;
extern PFNPROXYMULTIDRAWARRAYSEXTPROC pfnProxyMultiDrawArraysEXT;
extern PFNPROXYMULTIDRAWELEMENTSEXTPROC pfnProxyMultiDrawElementsEXT;
extern PFNPROXYRENDERBUFFERSTORAGEMULTISAMPLEIMGPROC pfnProxyRenderbufferStorageMultisampleIMG;
extern PFNPROXYFRAMEBUFFERTEXTURE2DMULTISAMPLEIMGPROC pfnProxyFramebufferTexture2DMultisampleIMG;
extern PFNPROXYDELETEFENCESNVPROC pfnProxyDeleteFencesNV;
extern PFNPROXYGENFENCESNVPROC pfnProxyGenFencesNV;
extern PFNPROXYISFENCENVPROC pfnProxyIsFenceNV;
extern PFNPROXYTESTFENCENVPROC pfnProxyTestFenceNV;
extern PFNPROXYGETFENCEIVNVPROC pfnProxyGetFenceivNV;
extern PFNPROXYFINISHFENCENVPROC pfnProxyFinishFenceNV;
extern PFNPROXYSETFENCENVPROC pfnProxySetFenceNV;
extern PFNPROXYCOVERAGEMASKNVPROC pfnProxyCoverageMaskNV;
extern PFNPROXYCOVERAGEOPERATIONNVPROC pfnProxyCoverageOperationNV;
extern PFNPROXYGETDRIVERCONTROLSQCOMPROC pfnProxyGetDriverControlsQCOM;
extern PFNPROXYGETDRIVERCONTROLSTRINGQCOMPROC pfnProxyGetDriverControlStringQCOM;
extern PFNPROXYENABLEDRIVERCONTROLQCOMPROC pfnProxyEnableDriverControlQCOM;
extern PFNPROXYDISABLEDRIVERCONTROLQCOMPROC pfnProxyDisableDriverControlQCOM;
extern PFNPROXYEXTGETTEXTURESQCOMPROC pfnProxyExtGetTexturesQCOM;
extern PFNPROXYEXTGETBUFFERSQCOMPROC pfnProxyExtGetBuffersQCOM;
extern PFNPROXYEXTGETRENDERBUFFERSQCOMPROC pfnProxyExtGetRenderbuffersQCOM;
extern PFNPROXYEXTGETFRAMEBUFFERSQCOMPROC pfnProxyExtGetFramebuffersQCOM;
extern PFNPROXYEXTGETTEXLEVELPARAMETERIVQCOMPROC pfnProxyExtGetTexLevelParameterivQCOM;
extern PFNPROXYEXTTEXOBJECTSTATEOVERRIDEIQCOMPROC pfnProxyExtTexObjectStateOverrideiQCOM;
extern PFNPROXYEXTGETTEXSUBIMAGEQCOMPROC pfnProxyExtGetTexSubImageQCOM;
extern PFNPROXYEXTGETBUFFERPOINTERVQCOMPROC pfnProxyExtGetBufferPointervQCOM;
extern PFNPROXYEXTGETSHADERSQCOMPROC pfnProxyExtGetShadersQCOM;
extern PFNPROXYEXTGETPROGRAMSQCOMPROC pfnProxyExtGetProgramsQCOM;
extern PFNPROXYEXTISPROGRAMBINARYQCOMPROC pfnProxyExtIsProgramBinaryQCOM;
extern PFNPROXYEXTGETPROGRAMBINARYSOURCEQCOMPROC pfnProxyExtGetProgramBinarySourceQCOM;
extern PFNPROXYSTARTTILINGQCOMPROC pfnProxyStartTilingQCOM;
extern PFNPROXYENDTILINGQCOMPROC pfnProxyEndTilingQCOM;

#ifdef __cplusplus
}
#endif

#endif
