/*
 * Copyright (c) 2007-2011 The Khronos Group Inc.
 * Copyright (C) 2010-2011 Linaro Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Authored-by: Jammy Zhou <jammy.zhou@linaro.org>
 */

#ifndef __GLXEXT_PROXY_H
#define __GLXEXT_PROXY_H

#ifdef __cplusplus
extern "C" {
#endif

/* --------------------------------------------------------------------------
 * Definitions from /usr/include/GL/glxext.h
 * ------------------------------------------------------------------------*/

// GLX_ARB_multisample
#define GLX_SAMPLE_BUFFERS_ARB             100000
#define GLX_SAMPLES_ARB                    100001

// GLX_ARB_vertex_buffer_object
#define GLX_CONTEXT_ALLOW_BUFFER_BYTE_ORDER_MISMATCH_ARB 0x2095

// GLX_ARB_fbconfig_float
#define GLX_RGBA_FLOAT_TYPE_ARB            0x20B9
#define GLX_RGBA_FLOAT_BIT_ARB             0x00000004

// GLX_ARB_framebuffer_sRGB
#define GLX_FRAMEBUFFER_SRGB_CAPABLE_ARB   0x20B2

// GLX_ARB_create_context
#define GLX_CONTEXT_DEBUG_BIT_ARB          0x00000001
#define GLX_CONTEXT_FORWARD_COMPATIBLE_BIT_ARB 0x00000002
#define GLX_CONTEXT_MAJOR_VERSION_ARB      0x2091
#define GLX_CONTEXT_MINOR_VERSION_ARB      0x2092
#define GLX_CONTEXT_FLAGS_ARB              0x2094

// GLX_ARB_create_context_profile
#define GLX_CONTEXT_CORE_PROFILE_BIT_ARB   0x00000001
#define GLX_CONTEXT_COMPATIBILITY_PROFILE_BIT_ARB 0x00000002
#define GLX_CONTEXT_PROFILE_MASK_ARB       0x9126

// GLX_ARB_create_context_robustness
#define GLX_CONTEXT_ROBUST_ACCESS_BIT_ARB  0x00000004
#define GLX_LOSE_CONTEXT_ON_RESET_ARB      0x8252
#define GLX_CONTEXT_RESET_NOTIFICATION_STRATEGY_ARB 0x8256
#define GLX_NO_RESET_NOTIFICATION_ARB      0x8261

// GLX_SGIS_multisample
#define GLX_SAMPLE_BUFFERS_SGIS            100000
#define GLX_SAMPLES_SGIS                   100001

// GLX_EXT_visual_info
#define GLX_X_VISUAL_TYPE_EXT              0x22
#define GLX_TRANSPARENT_TYPE_EXT           0x23
#define GLX_TRANSPARENT_INDEX_VALUE_EXT    0x24
#define GLX_TRANSPARENT_RED_VALUE_EXT      0x25
#define GLX_TRANSPARENT_GREEN_VALUE_EXT    0x26
#define GLX_TRANSPARENT_BLUE_VALUE_EXT     0x27
#define GLX_TRANSPARENT_ALPHA_VALUE_EXT    0x28
#define GLX_NONE_EXT                       0x8000
#define GLX_TRUE_COLOR_EXT                 0x8002
#define GLX_DIRECT_COLOR_EXT               0x8003
#define GLX_PSEUDO_COLOR_EXT               0x8004
#define GLX_STATIC_COLOR_EXT               0x8005
#define GLX_GRAY_SCALE_EXT                 0x8006
#define GLX_STATIC_GRAY_EXT                0x8007
#define GLX_TRANSPARENT_RGB_EXT            0x8008
#define GLX_TRANSPARENT_INDEX_EXT          0x8009

// GLX_EXT_visual_rating
#define GLX_VISUAL_CAVEAT_EXT              0x20
#define GLX_SLOW_VISUAL_EXT                0x8001
#define GLX_NON_CONFORMANT_VISUAL_EXT      0x800D

// GLX_EXT_import_context
#define GLX_SHARE_CONTEXT_EXT              0x800A
#define GLX_VISUAL_ID_EXT                  0x800B
#define GLX_SCREEN_EXT                     0x800C

// GLX_SGIX_fbconfig
#define GLX_WINDOW_BIT_SGIX                0x00000001
#define GLX_PIXMAP_BIT_SGIX                0x00000002
#define GLX_RGBA_BIT_SGIX                  0x00000001
#define GLX_COLOR_INDEX_BIT_SGIX           0x00000002
#define GLX_DRAWABLE_TYPE_SGIX             0x8010
#define GLX_RENDER_TYPE_SGIX               0x8011
#define GLX_X_RENDERABLE_SGIX              0x8012
#define GLX_FBCONFIG_ID_SGIX               0x8013
#define GLX_RGBA_TYPE_SGIX                 0x8014
#define GLX_COLOR_INDEX_TYPE_SGIX          0x8015

// GLX_SGIX_pbuffer
#define GLX_PBUFFER_BIT_SGIX               0x00000004
#define GLX_BUFFER_CLOBBER_MASK_SGIX       0x08000000
#define GLX_FRONT_LEFT_BUFFER_BIT_SGIX     0x00000001
#define GLX_FRONT_RIGHT_BUFFER_BIT_SGIX    0x00000002
#define GLX_BACK_LEFT_BUFFER_BIT_SGIX      0x00000004
#define GLX_BACK_RIGHT_BUFFER_BIT_SGIX     0x00000008
#define GLX_AUX_BUFFERS_BIT_SGIX           0x00000010
#define GLX_DEPTH_BUFFER_BIT_SGIX          0x00000020
#define GLX_STENCIL_BUFFER_BIT_SGIX        0x00000040
#define GLX_ACCUM_BUFFER_BIT_SGIX          0x00000080
#define GLX_SAMPLE_BUFFERS_BIT_SGIX        0x00000100
#define GLX_MAX_PBUFFER_WIDTH_SGIX         0x8016
#define GLX_MAX_PBUFFER_HEIGHT_SGIX        0x8017
#define GLX_MAX_PBUFFER_PIXELS_SGIX        0x8018
#define GLX_OPTIMAL_PBUFFER_WIDTH_SGIX     0x8019
#define GLX_OPTIMAL_PBUFFER_HEIGHT_SGIX    0x801A
#define GLX_PRESERVED_CONTENTS_SGIX        0x801B
#define GLX_LARGEST_PBUFFER_SGIX           0x801C
#define GLX_WIDTH_SGIX                     0x801D
#define GLX_HEIGHT_SGIX                    0x801E
#define GLX_EVENT_MASK_SGIX                0x801F
#define GLX_DAMAGED_SGIX                   0x8020
#define GLX_SAVED_SGIX                     0x8021
#define GLX_WINDOW_SGIX                    0x8022
#define GLX_PBUFFER_SGIX                   0x8023

// GLX_SGIX_video_resize
#define GLX_SYNC_FRAME_SGIX                0x00000000
#define GLX_SYNC_SWAP_SGIX                 0x00000001

// GLX_SGIX_dmbuffer
#define GLX_DIGITAL_MEDIA_PBUFFER_SGIX     0x8024

// GLX_SGIS_blended_overlay
#define GLX_BLENDED_RGBA_SGIS              0x8025

// GLX_SGIS_shared_multisample
#define GLX_MULTISAMPLE_SUB_RECT_WIDTH_SGIS 0x8026
#define GLX_MULTISAMPLE_SUB_RECT_HEIGHT_SGIS 0x8027

// GLX_3DFX_multisample
#define GLX_SAMPLE_BUFFERS_3DFX            0x8050
#define GLX_SAMPLES_3DFX                   0x8051

// GLX_MESA_set_3dfx_mode
#define GLX_3DFX_WINDOW_MODE_MESA          0x1
#define GLX_3DFX_FULLSCREEN_MODE_MESA      0x2

// GLX_SGIX_visual_select_group
#define GLX_VISUAL_SELECT_GROUP_SGIX       0x8028

// GLX_OML_swap_method
#define GLX_SWAP_METHOD_OML                0x8060
#define GLX_SWAP_EXCHANGE_OML              0x8061
#define GLX_SWAP_COPY_OML                  0x8062
#define GLX_SWAP_UNDEFINED_OML             0x8063

// GLX_NV_float_buffer
#define GLX_FLOAT_COMPONENTS_NV            0x20B0

// GLX_SGIX_hyperpipe
#define GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX 80
#define GLX_BAD_HYPERPIPE_CONFIG_SGIX      91
#define GLX_BAD_HYPERPIPE_SGIX             92
#define GLX_HYPERPIPE_DISPLAY_PIPE_SGIX    0x00000001
#define GLX_HYPERPIPE_RENDER_PIPE_SGIX     0x00000002
#define GLX_PIPE_RECT_SGIX                 0x00000001
#define GLX_PIPE_RECT_LIMITS_SGIX          0x00000002
#define GLX_HYPERPIPE_STEREO_SGIX          0x00000003
#define GLX_HYPERPIPE_PIXEL_AVERAGE_SGIX   0x00000004
#define GLX_HYPERPIPE_ID_SGIX              0x8030

// GLX_EXT_fbconfig_packed_float
#define GLX_RGBA_UNSIGNED_FLOAT_TYPE_EXT   0x20B1
#define GLX_RGBA_UNSIGNED_FLOAT_BIT_EXT    0x00000008

// GLX_EXT_framebuffer_sRGB
#define GLX_FRAMEBUFFER_SRGB_CAPABLE_EXT   0x20B2

// GLX_EXT_texture_from_pixmap
#define GLX_TEXTURE_1D_BIT_EXT             0x00000001
#define GLX_TEXTURE_2D_BIT_EXT             0x00000002
#define GLX_TEXTURE_RECTANGLE_BIT_EXT      0x00000004
#define GLX_BIND_TO_TEXTURE_RGB_EXT        0x20D0
#define GLX_BIND_TO_TEXTURE_RGBA_EXT       0x20D1
#define GLX_BIND_TO_MIPMAP_TEXTURE_EXT     0x20D2
#define GLX_BIND_TO_TEXTURE_TARGETS_EXT    0x20D3
#define GLX_Y_INVERTED_EXT                 0x20D4
#define GLX_TEXTURE_FORMAT_EXT             0x20D5
#define GLX_TEXTURE_TARGET_EXT             0x20D6
#define GLX_MIPMAP_TEXTURE_EXT             0x20D7
#define GLX_TEXTURE_FORMAT_NONE_EXT        0x20D8
#define GLX_TEXTURE_FORMAT_RGB_EXT         0x20D9
#define GLX_TEXTURE_FORMAT_RGBA_EXT        0x20DA
#define GLX_TEXTURE_1D_EXT                 0x20DB
#define GLX_TEXTURE_2D_EXT                 0x20DC
#define GLX_TEXTURE_RECTANGLE_EXT          0x20DD
#define GLX_FRONT_LEFT_EXT                 0x20DE
#define GLX_FRONT_RIGHT_EXT                0x20DF
#define GLX_BACK_LEFT_EXT                  0x20E0
#define GLX_BACK_RIGHT_EXT                 0x20E1
#define GLX_FRONT_EXT                      GLX_FRONT_LEFT_EXT
#define GLX_BACK_EXT                       GLX_BACK_LEFT_EXT
#define GLX_AUX0_EXT                       0x20E2
#define GLX_AUX1_EXT                       0x20E3
#define GLX_AUX2_EXT                       0x20E4
#define GLX_AUX3_EXT                       0x20E5
#define GLX_AUX4_EXT                       0x20E6
#define GLX_AUX5_EXT                       0x20E7
#define GLX_AUX6_EXT                       0x20E8
#define GLX_AUX7_EXT                       0x20E9
#define GLX_AUX8_EXT                       0x20EA
#define GLX_AUX9_EXT                       0x20EB

// GLX_NV_present_video
#define GLX_NUM_VIDEO_SLOTS_NV             0x20F0

// GLX_NV_video_out
#define GLX_VIDEO_OUT_COLOR_NV             0x20C3
#define GLX_VIDEO_OUT_ALPHA_NV             0x20C4
#define GLX_VIDEO_OUT_DEPTH_NV             0x20C5
#define GLX_VIDEO_OUT_COLOR_AND_ALPHA_NV   0x20C6
#define GLX_VIDEO_OUT_COLOR_AND_DEPTH_NV   0x20C7
#define GLX_VIDEO_OUT_FRAME_NV             0x20C8
#define GLX_VIDEO_OUT_FIELD_1_NV           0x20C9
#define GLX_VIDEO_OUT_FIELD_2_NV           0x20CA
#define GLX_VIDEO_OUT_STACKED_FIELDS_1_2_NV 0x20CB
#define GLX_VIDEO_OUT_STACKED_FIELDS_2_1_NV 0x20CC

// GLX_NV_video_capture
#define GLX_DEVICE_ID_NV                   0x20CD
#define GLX_UNIQUE_ID_NV                   0x20CE
#define GLX_NUM_VIDEO_CAPTURE_SLOTS_NV     0x20CF

// GLX_EXT_swap_control
#define GLX_SWAP_INTERVAL_EXT              0x20F1
#define GLX_MAX_SWAP_INTERVAL_EXT          0x20F2

// GLX_INTEL_swap_event
#define GLX_BUFFER_SWAP_COMPLETE_INTEL_MASK 0x04000000
#define GLX_EXCHANGE_COMPLETE_INTEL        0x8180
#define GLX_COPY_COMPLETE_INTEL            0x8181
#define GLX_FLIP_COMPLETE_INTEL            0x8182

// GLX_NV_multisample_coverage
#define GLX_COVERAGE_SAMPLES_NV            100001
#define GLX_COLOR_SAMPLES_NV               0x20B3

// GLX_AMD_gpu_association
#define GLX_GPU_VENDOR_AMD                 0x1F00
#define GLX_GPU_RENDERER_STRING_AMD        0x1F01
#define GLX_GPU_OPENGL_VERSION_STRING_AMD  0x1F02
#define GLX_GPU_FASTEST_TARGET_GPUS_AMD    0x21A2
#define GLX_GPU_RAM_AMD                    0x21A3
#define GLX_GPU_CLOCK_AMD                  0x21A4
#define GLX_GPU_NUM_PIPES_AMD              0x21A5
#define GLX_GPU_NUM_SIMD_AMD               0x21A6
#define GLX_GPU_NUM_RB_AMD                 0x21A7
#define GLX_GPU_NUM_SPI_AMD                0x21A8

// GLX_EXT_create_context_es2_profile
#define GLX_CONTEXT_ES2_PROFILE_BIT_EXT    0x00000004

// data structures
typedef XID GLXFBConfigIDSGIX;
typedef struct __GLXFBConfigRec *GLXFBConfigSGIX;

typedef XID GLXPbufferSGIX;
typedef struct {
    int type;
    unsigned long serial;         /* # of last request processed by server */
    Bool send_event;              /* true if this came for SendEvent request */
    Display *display;             /* display the event was read from */
    GLXDrawable drawable;         /* i.d. of Drawable */
    int event_type;               /* GLX_DAMAGED_SGIX or GLX_SAVED_SGIX */
    int draw_type;                /* GLX_WINDOW_SGIX or GLX_PBUFFER_SGIX */
    unsigned int mask;    /* mask indicating which buffers are affected*/
    int x, y;
    int width, height;
    int count;            /* if nonzero, at least this many more */
} GLXBufferClobberEventSGIX;

typedef struct {
    char    pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int     networkId;
} GLXHyperpipeNetworkSGIX;

typedef struct {
    char    pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int     channel;
    unsigned int
      participationType;
    int     timeSlice;
} GLXHyperpipeConfigSGIX;

typedef struct {
    char pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int srcXOrigin, srcYOrigin, srcWidth, srcHeight;
    int destXOrigin, destYOrigin, destWidth, destHeight;
} GLXPipeRect;

typedef struct {
    char pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int XOrigin, YOrigin, maxHeight, maxWidth;
} GLXPipeRectLimits;

typedef unsigned int GLXVideoDeviceNV;

typedef XID GLXVideoCaptureDeviceNV;

/* -----------------------------------------------------------
 * Function type definitions
 * ---------------------------------------------------------*/

// GLX_ARB_create_context
typedef GLXContext ( * PFNPROXYCREATECONTEXTATTRIBSARBPROC) (Display *dpy, GLXFBConfig config, GLXContext share_context, Bool direct, const int *attrib_list);

// GLX_SGI_swap_control
typedef int ( * PFNPROXYSWAPINTERVALSGIPROC) (int interval);

// GLX_SGI_video_sync
typedef int ( * PFNPROXYGETVIDEOSYNCSGIPROC) (unsigned int *count);
typedef int ( * PFNPROXYWAITVIDEOSYNCSGIPROC) (int divisor, int remainder, unsigned int *count);

// GLX_SGI_make_current_read
typedef Bool ( * PFNPROXYMAKECURRENTREADSGIPROC) (Display *dpy, GLXDrawable draw, GLXDrawable read, GLXContext ctx);
typedef GLXDrawable ( * PFNPROXYGETCURRENTREADDRAWABLESGIPROC) (void);

// GLX_SGIX_video_source
#ifdef _VL_H
typedef GLXVideoSourceSGIX ( * PFNPROXYCREATEGLXVIDEOSOURCESGIXPROC) (Display *display, int screen, VLServer server, VLPath path, int nodeClass, VLNode drainNode);
typedef void ( * PFNPROXYDESTROYGLXVIDEOSOURCESGIXPROC) (Display *dpy, GLXVideoSourceSGIX glxvideosource);
#endif

// GLX_EXT_import_context
typedef Display * ( * PFNPROXYGETCURRENTDISPLAYEXTPROC) (void);
typedef int ( * PFNPROXYQUERYCONTEXTINFOEXTPROC) (Display *dpy, GLXContext context, int attribute, int *value);
typedef GLXContextID ( * PFNPROXYGETCONTEXTIDEXTPROC) (const GLXContext context);
typedef GLXContext ( * PFNPROXYIMPORTCONTEXTEXTPROC) (Display *dpy, GLXContextID contextID);
typedef void ( * PFNPROXYFREECONTEXTEXTPROC) (Display *dpy, GLXContext context);

// GLX_SGIX_fbconfig
typedef int ( * PFNPROXYGETFBCONFIGATTRIBSGIXPROC) (Display *dpy, GLXFBConfigSGIX config, int attribute, int *value);
typedef GLXFBConfigSGIX * ( * PFNPROXYCHOOSEFBCONFIGSGIXPROC) (Display *dpy, int screen, int *attrib_list, int *nelements);
typedef GLXPixmap ( * PFNPROXYCREATEGLXPIXMAPWITHCONFIGSGIXPROC) (Display *dpy, GLXFBConfigSGIX config, Pixmap pixmap);
typedef GLXContext ( * PFNPROXYCREATECONTEXTWITHCONFIGSGIXPROC) (Display *dpy, GLXFBConfigSGIX config, int render_type, GLXContext share_list, Bool direct);
typedef XVisualInfo * ( * PFNPROXYGETVISUALFROMFBCONFIGSGIXPROC) (Display *dpy, GLXFBConfigSGIX config);
typedef GLXFBConfigSGIX ( * PFNPROXYGETFBCONFIGFROMVISUALSGIXPROC) (Display *dpy, XVisualInfo *vis);

// GLX_SGIX_pbuffer
typedef GLXPbufferSGIX ( * PFNPROXYCREATEGLXPBUFFERSGIXPROC) (Display *dpy, GLXFBConfigSGIX config, unsigned int width, unsigned int height, int *attrib_list);
typedef void ( * PFNPROXYDESTROYGLXPBUFFERSGIXPROC) (Display *dpy, GLXPbufferSGIX pbuf);
typedef int ( * PFNPROXYQUERYGLXPBUFFERSGIXPROC) (Display *dpy, GLXPbufferSGIX pbuf, int attribute, unsigned int *value);
typedef void ( * PFNPROXYSELECTEVENTSGIXPROC) (Display *dpy, GLXDrawable drawable, unsigned long mask);
typedef void ( * PFNPROXYGETSELECTEDEVENTSGIXPROC) (Display *dpy, GLXDrawable drawable, unsigned long *mask);

// GLX_SGI_cushion
typedef void ( * PFNPROXYCUSHIONSGIPROC) (Display *dpy, Window window, float cushion);

// GLX_SGIX_video_resize
typedef int ( * PFNPROXYBINDCHANNELTOWINDOWSGIXPROC) (Display *display, int screen, int channel, Window window);
typedef int ( * PFNPROXYCHANNELRECTSGIXPROC) (Display *display, int screen, int channel, int x, int y, int w, int h);
typedef int ( * PFNPROXYQUERYCHANNELRECTSGIXPROC) (Display *display, int screen, int channel, int *dx, int *dy, int *dw, int *dh);
typedef int ( * PFNPROXYQUERYCHANNELDELTASSGIXPROC) (Display *display, int screen, int channel, int *x, int *y, int *w, int *h);
typedef int ( * PFNPROXYCHANNELRECTSYNCSGIXPROC) (Display *display, int screen, int channel, GLenum synctype);

// GLX_SGIX_dmbuffer
#ifdef _DM_BUFFER_H
typedef Bool ( * PFNPROXYASSOCIATEDMPBUFFERSGIXPROC) (Display *dpy, GLXPbufferSGIX pbuffer, DMparams *params, DMbuffer dmbuffer);
#endif

// GLX_SGIX_swap_group
typedef void ( * PFNPROXYJOINSWAPGROUPSGIXPROC) (Display *dpy, GLXDrawable drawable, GLXDrawable member);

// GLX_SGIX_swap_barrier
typedef void ( * PFNPROXYBINDSWAPBARRIERSGIXPROC) (Display *dpy, GLXDrawable drawable, int barrier);
typedef Bool ( * PFNPROXYQUERYMAXSWAPBARRIERSSGIXPROC) (Display *dpy, int screen, int *max);

// GLX_SUN_get_transparent_index
typedef Status ( * PFNPROXYGETTRANSPARENTINDEXSUNPROC) (Display *dpy, Window overlay, Window underlay, long *pTransparentIndex);

// GLX_MESA_copy_sub_buffer
typedef void ( * PFNPROXYCOPYSUBBUFFERMESAPROC) (Display *dpy, GLXDrawable drawable, int x, int y, int width, int height);

// GLX_MESA_pixmap_colormap
typedef GLXPixmap ( * PFNPROXYCREATEGLXPIXMAPMESAPROC) (Display *dpy, XVisualInfo *visual, Pixmap pixmap, Colormap cmap);

// GLX_MESA_release_buffers
typedef Bool ( * PFNPROXYRELEASEBUFFERSMESAPROC) (Display *dpy, GLXDrawable drawable);

// GLX_MESA_set_3dfx_mode
typedef Bool ( * PFNPROXYSET3DFXMODEMESAPROC) (int mode);

// GLX_OML_sync_control
typedef Bool ( * PFNPROXYGETSYNCVALUESOMLPROC) (Display *dpy, GLXDrawable drawable, int64_t *ust, int64_t *msc, int64_t *sbc);
typedef Bool ( * PFNPROXYGETMSCRATEOMLPROC) (Display *dpy, GLXDrawable drawable, int32_t *numerator, int32_t *denominator);
typedef int64_t ( * PFNPROXYSWAPBUFFERSMSCOMLPROC) (Display *dpy, GLXDrawable drawable, int64_t target_msc, int64_t divisor, int64_t remainder);
typedef Bool ( * PFNPROXYWAITFORMSCOMLPROC) (Display *dpy, GLXDrawable drawable, int64_t target_msc, int64_t divisor, int64_t remainder, int64_t *ust, int64_t *msc, int64_t *sbc);
typedef Bool ( * PFNPROXYWAITFORSBCOMLPROC) (Display *dpy, GLXDrawable drawable, int64_t target_sbc, int64_t *ust, int64_t *msc, int64_t *sbc);

// GLX_SGIX_hyperpipe
typedef GLXHyperpipeNetworkSGIX * ( * PFNPROXYQUERYHYPERPIPENETWORKSGIXPROC) (Display *dpy, int *npipes);
typedef int ( * PFNPROXYHYPERPIPECONFIGSGIXPROC) (Display *dpy, int networkId, int npipes, GLXHyperpipeConfigSGIX *cfg, int *hpId);
typedef GLXHyperpipeConfigSGIX * ( * PFNPROXYQUERYHYPERPIPECONFIGSGIXPROC) (Display *dpy, int hpId, int *npipes);
typedef int ( * PFNPROXYDESTROYHYPERPIPECONFIGSGIXPROC) (Display *dpy, int hpId);
typedef int ( * PFNPROXYBINDHYPERPIPESGIXPROC) (Display *dpy, int hpId);
typedef int ( * PFNPROXYQUERYHYPERPIPEBESTATTRIBSGIXPROC) (Display *dpy, int timeSlice, int attrib, int size, void *attribList, void *returnAttribList);
typedef int ( * PFNPROXYHYPERPIPEATTRIBSGIXPROC) (Display *dpy, int timeSlice, int attrib, int size, void *attribList);
typedef int ( * PFNPROXYQUERYHYPERPIPEATTRIBSGIXPROC) (Display *dpy, int timeSlice, int attrib, int size, void *returnAttribList);

// GLX_MESA_agp_offset
typedef unsigned int ( * PFNPROXYGETAGPOFFSETMESAPROC) (const void *pointer);

// GLX_EXT_texture_from_pixmap
typedef void ( * PFNPROXYBINDTEXIMAGEEXTPROC) (Display *dpy, GLXDrawable drawable, int buffer, const int *attrib_list);
typedef void ( * PFNPROXYRELEASETEXIMAGEEXTPROC) (Display *dpy, GLXDrawable drawable, int buffer);

// GLX_NV_present_video
typedef unsigned int * ( * PFNPROXYENUMERATEVIDEODEVICESNVPROC) (Display *dpy, int screen, int *nelements);
typedef int ( * PFNPROXYBINDVIDEODEVICENVPROC) (Display *dpy, unsigned int video_slot, unsigned int video_device, const int *attrib_list);

// GLX_NV_video_output
typedef int ( * PFNPROXYGETVIDEODEVICENVPROC) (Display *dpy, int screen, int numVideoDevices, GLXVideoDeviceNV *pVideoDevice);
typedef int ( * PFNPROXYRELEASEVIDEODEVICENVPROC) (Display *dpy, int screen, GLXVideoDeviceNV VideoDevice);
typedef int ( * PFNPROXYBINDVIDEOIMAGENVPROC) (Display *dpy, GLXVideoDeviceNV VideoDevice, GLXPbuffer pbuf, int iVideoBuffer);
typedef int ( * PFNPROXYRELEASEVIDEOIMAGENVPROC) (Display *dpy, GLXPbuffer pbuf);
typedef int ( * PFNPROXYSENDPBUFFERTOVIDEONVPROC) (Display *dpy, GLXPbuffer pbuf, int iBufferType, unsigned long *pulCounterPbuffer, GLboolean bBlock);
typedef int ( * PFNPROXYGETVIDEOINFONVPROC) (Display *dpy, int screen, GLXVideoDeviceNV VideoDevice, unsigned long *pulCounterOutputPbuffer, unsigned long *pulCounterOutputVideo);

// GLX_NV_swap_group
typedef Bool ( * PFNPROXYJOINSWAPGROUPNVPROC) (Display *dpy, GLXDrawable drawable, GLuint group);
typedef Bool ( * PFNPROXYBINDSWAPBARRIERNVPROC) (Display *dpy, GLuint group, GLuint barrier);
typedef Bool ( * PFNPROXYQUERYSWAPGROUPNVPROC) (Display *dpy, GLXDrawable drawable, GLuint *group, GLuint *barrier);
typedef Bool ( * PFNPROXYQUERYMAXSWAPGROUPSNVPROC) (Display *dpy, int screen, GLuint *maxGroups, GLuint *maxBarriers);
typedef Bool ( * PFNPROXYQUERYFRAMECOUNTNVPROC) (Display *dpy, int screen, GLuint *count);
typedef Bool ( * PFNPROXYRESETFRAMECOUNTNVPROC) (Display *dpy, int screen);

// GLX_NV_video_capture
typedef int ( * PFNPROXYBINDVIDEOCAPTUREDEVICENVPROC) (Display *dpy, unsigned int video_capture_slot, GLXVideoCaptureDeviceNV device);
typedef GLXVideoCaptureDeviceNV * ( * PFNPROXYENUMERATEVIDEOCAPTUREDEVICESNVPROC) (Display *dpy, int screen, int *nelements);
typedef void ( * PFNPROXYLOCKVIDEOCAPTUREDEVICENVPROC) (Display *dpy, GLXVideoCaptureDeviceNV device);
typedef int ( * PFNPROXYQUERYVIDEOCAPTUREDEVICENVPROC) (Display *dpy, GLXVideoCaptureDeviceNV device, int attribute, int *value);
typedef void ( * PFNPROXYRELEASEVIDEOCAPTUREDEVICENVPROC) (Display *dpy, GLXVideoCaptureDeviceNV device);

// GLX_EXT_swap_control
typedef int ( * PFNPROXYSWAPINTERVALEXTPROC) (Display *dpy, GLXDrawable drawable, int interval);

// GLX_NV_copy_image
typedef void ( * PFNPROXYCOPYIMAGESUBDATANVPROC) (Display *dpy, GLXContext srcCtx, GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLXContext dstCtx, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei width, GLsizei height, GLsizei depth);

/* ---------------------------------------------------------------------------------------------
 * function rename
 * -------------------------------------------------------------------------------------------*/
#define glXCreateContextAttribsARB              pfnProxyCreateContextAttribsARB
#define glXSwapIntervalSGI                      pfnProxySwapIntervalSGI
#define glXGetVideoSyncSGI                      pfnProxyGetVideoSyncSGI
#define glXWaitVideoSyncSGI                     pfnProxyWaitVideoSyncSGI
#define glXMakeCurrentReadSGI                   pfnProxyMakeCurrentReadSGI
#define glXGetCurrentReadDrawableSGI            pfnProxyGetCurrentReadDrawableSGI
#ifdef _VL_H
#define glXCreateGLXVideoSourceSGIX             pfnProxyCreateGLXVideoSourceSGIX
#define glXDestroyGLXVideoSourceSGIX            pfnProxyDestroyGLXVideoSourceSGIX
#endif
#define glXGetCurrentDisplayEXT                 pfnProxyGetCurrentDisplayEXT
#define glXQueryContextInfoEXT                  pfnProxyQueryContextInfoEXT
#define glXGetContextIDEXT                      pfnProxyGetContextIDEXT
#define glXImportContextEXT                     pfnProxyImportContextEXT
#define glXFreeContextEXT                       pfnProxyFreeContextEXT
#define glXGetFBConfigAttribSGIX                pfnProxyGetFBConfigAttribSGIX
#define glXChooseFBConfigSGIX                   pfnProxyChooseFBConfigSGIX
#define glXCreateGLXPixmapWithConfigSGIX        pfnProxyCreateGLXPixmapWithConfigSGIX
#define glXCreateContextWithConfigSGIX          pfnProxyCreateContextWithConfigSGIX
#define glXGetVisualFromFBConfigSGIX            pfnProxyGetVisualFromFBConfigSGIX
#define glXGetFBConfigFromVisualSGIX            pfnProxyGetFBConfigFromVisualSGIX
#define glXCreateGLXPbufferSGIX                 pfnProxyCreateGLXPbufferSGIX
#define glXDestroyGLXPbufferSGIX                pfnProxyDestroyGLXPbufferSGIX
#define glXQueryGLXPbufferSGIX                  pfnProxyQueryGLXPbufferSGIX
#define glXSelectEventSGIX                      pfnProxySelectEventSGIX
#define glXGetSelectedEventSGIX                 pfnProxyGetSelectedEventSGIX
#define glXCushionSGI                           pfnProxyCushionSGI
#define glXBindChannelToWindowSGIX              pfnProxyBindChannelToWindowSGIX
#define glXChannelRectSGIX                      pfnProxyChannelRectSGIX
#define glXQueryChannelRectSGIX                 pfnProxyQueryChannelRectSGIX
#define glXQueryChannelDeltasSGIX               pfnProxyQueryChannelDeltasSGIX
#define glXChannelRectSyncSGIX                  pfnProxyChannelRectSyncSGIX
#ifdef _DM_BUFFER_H
#define glXAssociateDMPbufferSGIX               pfnProxyAssociateDMPbufferSGIX
#endif
#define glXJoinSwapGroupSGIX                    pfnProxyJoinSwapGroupSGIX
#define glXBindSwapBarrierSGIX                  pfnProxyBindSwapBarrierSGIX
#define glXQueryMaxSwapBarriersSGIX             pfnProxyQueryMaxSwapBarriersSGIX
#define glXGetTransparentIndexSUN               pfnProxyGetTransparentIndexSUN
#define glXCopySubBufferMESA                    pfnProxyCopySubBufferMESA
#define glXCreateGLXPixmapMESA                  pfnProxyCreateGLXPixmapMESA
#define glXReleaseBuffersMESA                   pfnProxyReleaseBuffersMESA
#define glXSet3DfxModeMESA                      pfnProxySet3DfxModeMESA
#define glXGetSyncValuesOML                     pfnProxyGetSyncValuesOML
#define glXGetMscRateOML                        pfnProxyGetMscRateOML
#define glXSwapBuffersMscOML                    pfnProxySwapBuffersMscOML
#define glXWaitForMscOML                        pfnProxyWaitForMscOML
#define glXWaitForSbcOML                        pfnProxyWaitForSbcOML
#define glXQueryHyperpipeNetworkSGIX            pfnProxyQueryHyperpipeNetworkSGIX
#define glXHyperpipeConfigSGIX                  pfnProxyHyperpipeConfigSGIX
#define glXQueryHyperpipeConfigSGIX             pfnProxyQueryHyperpipeConfigSGIX
#define glXDestroyHyperpipeConfigSGIX           pfnProxyDestroyHyperpipeConfigSGIX
#define glXBindHyperpipeSGIX                    pfnProxyBindHyperpipeSGIX
#define glXQueryHyperpipeBestAttribSGIX         pfnProxyQueryHyperpipeBestAttribSGIX
#define glXHyperpipeAttribSGIX                  pfnProxyHyperpipeAttribSGIX
#define glXQueryHyperpipeAttribSGIX             pfnProxyQueryHyperpipeAttribSGIX
#define glXGetAGPOffsetMESA                     pfnProxyGetAGPOffsetMESA
#define glXBindTexImageEXT                      pfnProxyBindTexImageEXT
#define glXReleaseTexImageEXT                   pfnProxyReleaseTexImageEXT
#define glXEnumerateVideoDevicesNV              pfnProxyEnumerateVideoDevicesNV
#define glXBindVideoDeviceNV                    pfnProxyBindVideoDeviceNV
#define glXGetVideoDeviceNV                     pfnProxyBindVideoDeviceNV
#define glXReleaseVideoDeviceNV                 pfnProxyReleaseVideoDeviceNV
#define glXBindVideoImageNV                     pfnProxyBindVideoImageNV
#define glXReleaseVideoImageNV                  pfnProxyReleaseVideoImageNV
#define glXSendPbufferToVideoNV                 pfnProxySendPbufferToVideoNV
#define glXGetVideoInfoNV                       pfnProxyGetVideoInfoNV
#define glXJoinSwapGroupNV                      pfnProxyJoinSwapGroupNV
#define glXBindSwapBarrierNV                    pfnProxyBindSwapBarrierNV
#define glXQuerySwapGroupNV                     pfnProxyQuerySwapGroupNV
#define glXQueryMaxSwapGroupsNV                 pfnProxyQueryMaxSwapGroupsNV
#define glXQueryFrameCountNV                    pfnProxyQueryFrameCountNV
#define glXResetFrameCountNV                    pfnProxyResetFrameCountNV
#define glXBindVideoCaptureDeviceNV             pfnProxyBindVideoCaptureDeviceNV
#define glXEnumerateVideoCaptureDevicesNV       pfnProxyEnumerateVideoCaptureDevicesNV
#define glXLockVideoCaptureDeviceNV             pfnProxyLockVideoCaptureDeviceNV
#define glXQueryVideoCaptureDeviceNV            pfnProxyQueryVideoCaptureDeviceNV
#define glXReleaseVideoCaptureDeviceNV          pfnProxyReleaseVideoCaptureDeviceNV
#define glXSwapIntervalEXT                      pfnProxySwapIntervalEXT
#define glXCopyImageSubDataNV                   pfnProxyCopyImageSubDataNV

/* ---------------------------------------------------------------------------------------------
 * export proxy functions
 * -------------------------------------------------------------------------------------------*/
extern PFNPROXYCREATECONTEXTATTRIBSARBPROC     pfnProxyCreateContextAttribsARB;
extern PFNPROXYSWAPINTERVALSGIPROC             pfnProxySwapIntervalSGI;
extern PFNPROXYGETVIDEOSYNCSGIPROC             pfnProxyGetVideoSyncSGI;
extern PFNPROXYWAITVIDEOSYNCSGIPROC            pfnProxyWaitVideoSyncSGI;
extern PFNPROXYMAKECURRENTREADSGIPROC          pfnProxyMakeCurrentReadSGI;
extern PFNPROXYGETCURRENTREADDRAWABLESGIPROC   pfnProxyGetCurrentReadDrawableSGI;
#ifdef _VL_H
extern PFNPROXYCREATEGLXVIDEOSOURCESGIXPROC    pfnProxyCreateGLXVideoSourceSGIX;
extern PFNPROXYDESTROYGLXVIDEOSOURCESGIXPROC   pfnProxyDestroyGLXVideoSourceSGIX;
#endif
extern PFNPROXYGETCURRENTDISPLAYEXTPROC        pfnProxyGetCurrentDisplayEXT;
extern PFNPROXYQUERYCONTEXTINFOEXTPROC         pfnProxyQueryContextInfoEXT;
extern PFNPROXYGETCONTEXTIDEXTPROC             pfnProxyGetContextIDEXT;
extern PFNPROXYIMPORTCONTEXTEXTPROC            pfnProxyImportContextEXT;
extern PFNPROXYFREECONTEXTEXTPROC              pfnProxyFreeContextEXT;
extern PFNPROXYGETFBCONFIGATTRIBSGIXPROC       pfnProxyGetFBConfigAttribSGIX;
extern PFNPROXYCHOOSEFBCONFIGSGIXPROC          pfnProxyChooseFBConfigSGIX;
extern PFNPROXYCREATEGLXPIXMAPWITHCONFIGSGIXPROC pfnProxyCreateGLXPixmapWithConfigSGIX;
extern PFNPROXYCREATECONTEXTWITHCONFIGSGIXPROC pfnProxyCreateContextWithConfigSGIX;
extern PFNPROXYGETVISUALFROMFBCONFIGSGIXPROC   pfnProxyGetVisualFromFBConfigSGIX;
extern PFNPROXYGETFBCONFIGFROMVISUALSGIXPROC   pfnProxyGetFBConfigFromVisualSGIX;
extern PFNPROXYCREATEGLXPBUFFERSGIXPROC        pfnProxyCreateGLXPbufferSGIX;
extern PFNPROXYDESTROYGLXPBUFFERSGIXPROC       pfnProxyDestroyGLXPbufferSGIX;
extern PFNPROXYQUERYGLXPBUFFERSGIXPROC         pfnProxyQueryGLXPbufferSGIX;
extern PFNPROXYSELECTEVENTSGIXPROC             pfnProxySelectEventSGIX;
extern PFNPROXYGETSELECTEDEVENTSGIXPROC        pfnProxyGetSelectedEventSGIX;
extern PFNPROXYCUSHIONSGIPROC                  pfnProxyCushionSGI;
extern PFNPROXYBINDCHANNELTOWINDOWSGIXPROC     pfnProxyBindChannelToWindowSGIX;
extern PFNPROXYCHANNELRECTSGIXPROC             pfnProxyChannelRectSGIX;
extern PFNPROXYQUERYCHANNELRECTSGIXPROC        pfnProxyQueryChannelRectSGIX;
extern PFNPROXYQUERYCHANNELDELTASSGIXPROC      pfnProxyQueryChannelDeltasSGIX;
extern PFNPROXYCHANNELRECTSYNCSGIXPROC         pfnProxyChannelRectSyncSGIX;
#ifdef _DM_BUFFER_H
extern PFNPROXYASSOCIATEDMPBUFFERSGIXPROC      pfnProxyAssociateDMPbufferSGIX;
#endif
extern PFNPROXYJOINSWAPGROUPSGIXPROC           pfnProxyJoinSwapGroupSGIX;
extern PFNPROXYBINDSWAPBARRIERSGIXPROC         pfnProxyBindSwapBarrierSGIX;
extern PFNPROXYQUERYMAXSWAPBARRIERSSGIXPROC    pfnProxyQueryMaxSwapBarriersSGIX;
extern PFNPROXYGETTRANSPARENTINDEXSUNPROC      pfnProxyGetTransparentIndexSUN;
extern PFNPROXYCOPYSUBBUFFERMESAPROC           pfnProxyCopySubBufferMESA;
extern PFNPROXYCREATEGLXPIXMAPMESAPROC         pfnProxyCreateGLXPixmapMESA;
extern PFNPROXYRELEASEBUFFERSMESAPROC          pfnProxyReleaseBuffersMESA;
extern PFNPROXYSET3DFXMODEMESAPROC             pfnProxySet3DfxModeMESA;
extern PFNPROXYGETSYNCVALUESOMLPROC            pfnProxyGetSyncValuesOML;
extern PFNPROXYGETMSCRATEOMLPROC               pfnProxyGetMscRateOML;
extern PFNPROXYSWAPBUFFERSMSCOMLPROC           pfnProxySwapBuffersMscOML;
extern PFNPROXYWAITFORMSCOMLPROC               pfnProxyWaitForMscOML;
extern PFNPROXYWAITFORSBCOMLPROC               pfnProxyWaitForSbcOML;
extern PFNPROXYQUERYHYPERPIPENETWORKSGIXPROC   pfnProxyQueryHyperpipeNetworkSGIX;
extern PFNPROXYHYPERPIPECONFIGSGIXPROC         pfnProxyHyperpipeConfigSGIX;
extern PFNPROXYQUERYHYPERPIPECONFIGSGIXPROC    pfnProxyQueryHyperpipeConfigSGIX;
extern PFNPROXYDESTROYHYPERPIPECONFIGSGIXPROC  pfnProxyDestroyHyperpipeConfigSGIX;
extern PFNPROXYBINDHYPERPIPESGIXPROC           pfnProxyBindHyperpipeSGIX;
extern PFNPROXYQUERYHYPERPIPEBESTATTRIBSGIXPROC pfnProxyQueryHyperpipeBestAttribSGIX;
extern PFNPROXYHYPERPIPEATTRIBSGIXPROC         pfnProxyHyperpipeAttribSGIX;
extern PFNPROXYQUERYHYPERPIPEATTRIBSGIXPROC    pfnProxyQueryHyperpipeAttribSGIX;
extern PFNPROXYGETAGPOFFSETMESAPROC            pfnProxyGetAGPOffsetMESA;
extern PFNPROXYBINDTEXIMAGEEXTPROC             pfnProxyBindTexImageEXT;
extern PFNPROXYRELEASETEXIMAGEEXTPROC          pfnProxyReleaseTexImageEXT;
extern PFNPROXYENUMERATEVIDEODEVICESNVPROC     pfnProxyEnumerateVideoDevicesNV;
extern PFNPROXYBINDVIDEODEVICENVPROC           pfnProxyBindVideoDeviceNV;
extern PFNPROXYGETVIDEODEVICENVPROC            pfnProxyGetVideoDeviceNV;
extern PFNPROXYRELEASEVIDEODEVICENVPROC        pfnProxyReleaseVideoDeviceNV;
extern PFNPROXYBINDVIDEOIMAGENVPROC            pfnProxyBindVideoImageNV;
extern PFNPROXYRELEASEVIDEOIMAGENVPROC         pfnProxyReleaseVideoImageNV;
extern PFNPROXYSENDPBUFFERTOVIDEONVPROC        pfnProxySendPbufferToVideoNV;
extern PFNPROXYGETVIDEOINFONVPROC              pfnProxyGetVideoInfoNV;
extern PFNPROXYJOINSWAPGROUPNVPROC             pfnProxyJoinSwapGroupNV;
extern PFNPROXYBINDSWAPBARRIERNVPROC           pfnProxyBindSwapBarrierNV;
extern PFNPROXYQUERYSWAPGROUPNVPROC            pfnProxyQuerySwapGroupNV;
extern PFNPROXYQUERYMAXSWAPGROUPSNVPROC        pfnProxyQueryMaxSwapGroupsNV;
extern PFNPROXYQUERYFRAMECOUNTNVPROC           pfnProxyQueryFrameCountNV;
extern PFNPROXYRESETFRAMECOUNTNVPROC           pfnProxyResetFrameCountNV;
extern PFNPROXYBINDVIDEOCAPTUREDEVICENVPROC    pfnProxyBindVideoCaptureDeviceNV;
extern PFNPROXYENUMERATEVIDEOCAPTUREDEVICESNVPROC pfnProxyEnumerateVideoCaptureDevicesNV;
extern PFNPROXYLOCKVIDEOCAPTUREDEVICENVPROC    pfnProxyLockVideoCaptureDeviceNV;
extern PFNPROXYQUERYVIDEOCAPTUREDEVICENVPROC   pfnProxyQueryVideoCaptureDeviceNV;
extern PFNPROXYRELEASEVIDEOCAPTUREDEVICENVPROC pfnProxyReleaseVideoCaptureDeviceNV;
extern PFNPROXYSWAPINTERVALEXTPROC             pfnProxySwapIntervalEXT;
extern PFNPROXYCOPYIMAGESUBDATANVPROC          pfnProxyCopyImageSubDataNV;

#ifdef __cplusplus
}
#endif

#endif
