/* Copyright (C) 2010-2011 Linaro Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Authored-by: Jammy Zhou <jammy.zhou@linaro.org>
 */

#include <stdlib.h>

#include <GL/gl_proxy.h>
#include <GL/glext_proxy.h>

/* proxy functions for GLES2 extensions */
PFNPROXYEGLIMAGETARGETTEXTURE2DOESPROC pfnProxyEGLImageTargetTexture2DOES = NULL;
PFNPROXYEGLIMAGETARGETRENDERBUFFERSTORAGEOESPROC pfnProxyEGLImageTargetRenderbufferStorageOES = NULL;
PFNPROXYGETPROGRAMBINARYOESPROC pfnProxyGetProgramBinaryOES = NULL;
PFNPROXYPROGRAMBINARYOESPROC pfnProxyProgramBinaryOES = NULL;
PFNPROXYMAPBUFFEROESPROC pfnProxyMapBufferOES = NULL;
PFNPROXYUNMAPBUFFEROESPROC pfnProxyUnmapBufferOES = NULL;
PFNPROXYGETBUFFERPOINTERVOESPROC pfnProxyGetBufferPointervOES = NULL;
PFNPROXYTEXIMAGE3DOESPROC pfnProxyTexImage3DOES = NULL;
PFNPROXYTEXSUBIMAGE3DOESPROC pfnProxyTexSubImage3DOES = NULL;
PFNPROXYCOPYTEXSUBIMAGE3DOESPROC pfnProxyCopyTexSubImage3DOES = NULL;
PFNPROXYCOMPRESSEDTEXIMAGE3DOESPROC pfnProxyCompressedTexImage3DOES = NULL;
PFNPROXYCOMPRESSEDTEXSUBIMAGE3DOESPROC pfnProxyCompressedTexSubImage3DOES = NULL;
PFNPROXYFRAMEBUFFERTEXTURE3DOESPROC pfnProxyFramebufferTexture3DOES = NULL;
PFNPROXYBINDVERTEXARRAYOESPROC pfnProxyBindVertexArrayOES = NULL;
PFNPROXYDELETEVERTEXARRAYSOESPROC pfnProxyDeleteVertexArraysOES = NULL;
PFNPROXYGENVERTEXARRAYSOESPROC pfnProxyGenVertexArraysOES = NULL;
PFNPROXYISVERTEXARRAYOESPROC pfnProxyIsVertexArrayOES = NULL;
PFNPROXYGETPERFMONITORGROUPSAMDPROC pfnProxyGetPerfMonitorGroupsAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERSAMDPROC pfnProxyGetPerfMonitorCountersAMD = NULL;
PFNPROXYGETPERFMONITORGROUPSTRINGAMDPROC pfnProxyGetPerfMonitorGroupStringAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERSTRINGAMDPROC pfnProxyGetPerfMonitorCounterStringAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERINFOAMDPROC pfnProxyGetPerfMonitorCounterInfoAMD = NULL;
PFNPROXYGENPERFMONITORSAMDPROC pfnProxyGenPerfMonitorsAMD = NULL;
PFNPROXYDELETEPERFMONITORSAMDPROC pfnProxyDeletePerfMonitorsAMD = NULL;
PFNPROXYSELECTPERFMONITORCOUNTERSAMDPROC pfnProxySelectPerfMonitorCountersAMD = NULL;
PFNPROXYBEGINPERFMONITORAMDPROC pfnProxyBeginPerfMonitorAMD = NULL;
PFNPROXYENDPERFMONITORAMDPROC pfnProxyEndPerfMonitorAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERDATAAMDPROC pfnProxyGetPerfMonitorCounterDataAMD = NULL;
PFNPROXYDISCARDFRAMEBUFFEREXTPROC pfnProxyDiscardFramebufferEXT = NULL;
PFNPROXYMULTIDRAWARRAYSEXTPROC pfnProxyMultiDrawArraysEXT = NULL;
PFNPROXYMULTIDRAWELEMENTSEXTPROC pfnProxyMultiDrawElementsEXT = NULL;
PFNPROXYRENDERBUFFERSTORAGEMULTISAMPLEIMGPROC pfnProxyRenderbufferStorageMultisampleIMG = NULL;
PFNPROXYFRAMEBUFFERTEXTURE2DMULTISAMPLEIMGPROC pfnProxyFramebufferTexture2DMultisampleIMG = NULL;
PFNPROXYDELETEFENCESNVPROC pfnProxyDeleteFencesNV = NULL;
PFNPROXYGENFENCESNVPROC pfnProxyGenFencesNV = NULL;
PFNPROXYISFENCENVPROC pfnProxyIsFenceNV = NULL;
PFNPROXYTESTFENCENVPROC pfnProxyTestFenceNV = NULL;
PFNPROXYGETFENCEIVNVPROC pfnProxyGetFenceivNV = NULL;
PFNPROXYFINISHFENCENVPROC pfnProxyFinishFenceNV = NULL;
PFNPROXYSETFENCENVPROC pfnProxySetFenceNV = NULL;
PFNPROXYCOVERAGEMASKNVPROC pfnProxyCoverageMaskNV = NULL;
PFNPROXYCOVERAGEOPERATIONNVPROC pfnProxyCoverageOperationNV = NULL;
PFNPROXYGETDRIVERCONTROLSQCOMPROC pfnProxyGetDriverControlsQCOM = NULL;
PFNPROXYGETDRIVERCONTROLSTRINGQCOMPROC pfnProxyGetDriverControlStringQCOM = NULL;
PFNPROXYENABLEDRIVERCONTROLQCOMPROC pfnProxyEnableDriverControlQCOM = NULL;
PFNPROXYDISABLEDRIVERCONTROLQCOMPROC pfnProxyDisableDriverControlQCOM = NULL;
PFNPROXYEXTGETTEXTURESQCOMPROC pfnProxyExtGetTexturesQCOM = NULL;
PFNPROXYEXTGETBUFFERSQCOMPROC pfnProxyExtGetBuffersQCOM = NULL;
PFNPROXYEXTGETRENDERBUFFERSQCOMPROC pfnProxyExtGetRenderbuffersQCOM = NULL;
PFNPROXYEXTGETFRAMEBUFFERSQCOMPROC pfnProxyExtGetFramebuffersQCOM = NULL;
PFNPROXYEXTGETTEXLEVELPARAMETERIVQCOMPROC pfnProxyExtGetTexLevelParameterivQCOM = NULL;
PFNPROXYEXTTEXOBJECTSTATEOVERRIDEIQCOMPROC pfnProxyExtTexObjectStateOverrideiQCOM = NULL;
PFNPROXYEXTGETTEXSUBIMAGEQCOMPROC pfnProxyExtGetTexSubImageQCOM = NULL;
PFNPROXYEXTGETBUFFERPOINTERVQCOMPROC pfnProxyExtGetBufferPointervQCOM = NULL;
PFNPROXYEXTGETSHADERSQCOMPROC pfnProxyExtGetShadersQCOM = NULL;
PFNPROXYEXTGETPROGRAMSQCOMPROC pfnProxyExtGetProgramsQCOM = NULL;
PFNPROXYEXTISPROGRAMBINARYQCOMPROC pfnProxyExtIsProgramBinaryQCOM = NULL;
PFNPROXYEXTGETPROGRAMBINARYSOURCEQCOMPROC pfnProxyExtGetProgramBinarySourceQCOM = NULL;
PFNPROXYSTARTTILINGQCOMPROC pfnProxyStartTilingQCOM = NULL;
PFNPROXYENDTILINGQCOMPROC pfnProxyEndTilingQCOM = NULL;

/* Symbol resolve */
extern void *glProxyGetExtProcAddr(void *handle, const char *name);

int glProxyExtInitGLES2(void *handle)
{
	if (NULL == handle) {
		return -1;
	}

	pfnProxyEGLImageTargetTexture2DOES = glProxyGetExtProcAddr(handle, "glEGLImageTargetTexture2DOES");
	pfnProxyEGLImageTargetRenderbufferStorageOES = glProxyGetExtProcAddr(handle, "glEGLImageTargetRenderbufferStorageOES");
	pfnProxyGetProgramBinaryOES = glProxyGetExtProcAddr(handle, "glGetProgramBinaryOES");
	pfnProxyProgramBinaryOES = glProxyGetExtProcAddr(handle, "glProgramBinaryOES");
	pfnProxyMapBufferOES = glProxyGetExtProcAddr(handle, "glMapBufferOES");
	pfnProxyUnmapBufferOES = glProxyGetExtProcAddr(handle, "glUnmapBufferOES");
	pfnProxyGetBufferPointervOES = glProxyGetExtProcAddr(handle, "glGetBufferPointervOES");
	pfnProxyTexImage3DOES = glProxyGetExtProcAddr(handle, "glTexImage3DOES");
	pfnProxyTexSubImage3DOES = glProxyGetExtProcAddr(handle, "glTexSubImage3DOES");
	pfnProxyCopyTexSubImage3DOES = glProxyGetExtProcAddr(handle, "glCopyTexSubImage3DOES");
	pfnProxyCompressedTexImage3DOES = glProxyGetExtProcAddr(handle, "glCompressedTexImage3DOES");
	pfnProxyCompressedTexSubImage3DOES = glProxyGetExtProcAddr(handle, "glCompressedTexSubImage3DOES");
	pfnProxyFramebufferTexture3DOES = glProxyGetExtProcAddr(handle, "glFramebufferTexture3DOES");
	pfnProxyBindVertexArrayOES = glProxyGetExtProcAddr(handle, "glBindVertexArrayOES");
	pfnProxyDeleteVertexArraysOES = glProxyGetExtProcAddr(handle, "glDeleteVertexArraysOES");
	pfnProxyGenVertexArraysOES = glProxyGetExtProcAddr(handle, "glGenVertexArraysOES");
	pfnProxyIsVertexArrayOES = glProxyGetExtProcAddr(handle, "glIsVertexArrayOES");
	pfnProxyGetPerfMonitorGroupsAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorGroupsAMD");
	pfnProxyGetPerfMonitorCountersAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorCountersAMD");
	pfnProxyGetPerfMonitorGroupStringAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorGroupStringAMD");
	pfnProxyGetPerfMonitorCounterStringAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorCounterStringAMD");
	pfnProxyGetPerfMonitorCounterInfoAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorCounterInfoAMD");
	pfnProxyGenPerfMonitorsAMD = glProxyGetExtProcAddr(handle, "glGenPerfMonitorsAMD");
	pfnProxyDeletePerfMonitorsAMD = glProxyGetExtProcAddr(handle, "glDeletePerfMonitorsAMD");
	pfnProxySelectPerfMonitorCountersAMD = glProxyGetExtProcAddr(handle, "glSelectPerfMonitorCountersAMD");
	pfnProxyBeginPerfMonitorAMD = glProxyGetExtProcAddr(handle, "glBeginPerfMonitorAMD");
	pfnProxyEndPerfMonitorAMD = glProxyGetExtProcAddr(handle, "glEndPerfMonitorAMD");
	pfnProxyGetPerfMonitorCounterDataAMD = glProxyGetExtProcAddr(handle, "glGetPerfMonitorCounterDataAMD");
	pfnProxyDiscardFramebufferEXT = glProxyGetExtProcAddr(handle, "glDiscardFramebufferEXT");
	pfnProxyMultiDrawArraysEXT = glProxyGetExtProcAddr(handle, "glMultiDrawArraysEXT");
	pfnProxyMultiDrawElementsEXT = glProxyGetExtProcAddr(handle, "glMultiDrawElementsEXT");
	pfnProxyRenderbufferStorageMultisampleIMG = glProxyGetExtProcAddr(handle, "glRenderbufferStorageMultisampleIMG");
	pfnProxyFramebufferTexture2DMultisampleIMG = glProxyGetExtProcAddr(handle, "glFramebufferTexture2DMultisampleIMG");
	pfnProxyDeleteFencesNV = glProxyGetExtProcAddr(handle, "glDeleteFencesNV");
	pfnProxyGenFencesNV = glProxyGetExtProcAddr(handle, "glGenFencesNV");
	pfnProxyIsFenceNV = glProxyGetExtProcAddr(handle, "glIsFenceNV");
	pfnProxyTestFenceNV = glProxyGetExtProcAddr(handle, "glTestFenceNV");
	pfnProxyGetFenceivNV = glProxyGetExtProcAddr(handle, "glGetFenceivNV");
	pfnProxyFinishFenceNV = glProxyGetExtProcAddr(handle, "glFinishFenceNV");
	pfnProxySetFenceNV = glProxyGetExtProcAddr(handle, "glSetFenceNV");
	pfnProxyCoverageMaskNV = glProxyGetExtProcAddr(handle, "glCoverageMaskNV");
	pfnProxyCoverageOperationNV = glProxyGetExtProcAddr(handle, "glCoverageOperationNV");
	pfnProxyGetDriverControlsQCOM = glProxyGetExtProcAddr(handle, "glGetDriverControlsQCOM");
	pfnProxyGetDriverControlStringQCOM = glProxyGetExtProcAddr(handle, "glGetDriverControlStringQCOM");
	pfnProxyEnableDriverControlQCOM = glProxyGetExtProcAddr(handle, "glEnableDriverControlQCOM");
	pfnProxyDisableDriverControlQCOM = glProxyGetExtProcAddr(handle, "glDisableDriverControlQCOM");
	pfnProxyExtGetTexturesQCOM = glProxyGetExtProcAddr(handle, "glExtGetTexturesQCOM");
	pfnProxyExtGetBuffersQCOM = glProxyGetExtProcAddr(handle, "glExtGetBuffersQCOM");
	pfnProxyExtGetRenderbuffersQCOM = glProxyGetExtProcAddr(handle, "glExtGetRenderbuffersQCOM");
	pfnProxyExtGetFramebuffersQCOM = glProxyGetExtProcAddr(handle, "glExtGetFramebuffersQCOM");
	pfnProxyExtGetTexLevelParameterivQCOM = glProxyGetExtProcAddr(handle, "glExtGetTexLevelParameterivQCOM");
	pfnProxyExtTexObjectStateOverrideiQCOM = glProxyGetExtProcAddr(handle, "glExtTexObjectStateOverrideiQCOM");
	pfnProxyExtGetTexSubImageQCOM = glProxyGetExtProcAddr(handle, "glExtGetTexSubImageQCOM");
	pfnProxyExtGetBufferPointervQCOM = glProxyGetExtProcAddr(handle, "glExtGetBufferPointervQCOM");
	pfnProxyExtGetShadersQCOM = glProxyGetExtProcAddr(handle, "glExtGetShadersQCOM");
	pfnProxyExtGetProgramsQCOM = glProxyGetExtProcAddr(handle, "glExtGetProgramsQCOM");
	pfnProxyExtIsProgramBinaryQCOM = glProxyGetExtProcAddr(handle, "glExtIsProgramBinaryQCOM");
	pfnProxyExtGetProgramBinarySourceQCOM = glProxyGetExtProcAddr(handle, "glExtGetProgramBinarySourceQCOM");
	pfnProxyStartTilingQCOM = glProxyGetExtProcAddr(handle, "glStartTilingQCOM");
	pfnProxyEndTilingQCOM = glProxyGetExtProcAddr(handle, "glEndTilingQCOM");
}

int glProxyExtInitGL(void *handle)
{
	/* TODO */
	return 0;
}
