/* Copyright (C) 2010-2011 Linaro Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Authored-by: Jammy Zhou <jammy.zhou@linaro.org>
 */

#include <GL/gl_proxy.h>
#include <GL/glx_proxy.h>
#include <GL/glxext_proxy.h>

PFNPROXYCHOOSEVISUALPROC            pfnProxyChooseVisual = NULL;
PFNPROXYCREATECONTEXTPROC           pfnProxyCreateContext = NULL;
PFNPROXYDESTROYCONTEXTPROC          pfnProxyDestroyContext = NULL;
PFNPROXYMAKECURRENTPROC             pfnProxyMakeCurrent = NULL;
PFNPROXYCOPYCONTEXTPROC             pfnProxyCopyContext = NULL;
PFNPROXYSWAPBUFFERSPROC             pfnProxySwapBuffers = NULL;
PFNPROXYCREATEGLXPIXMAPPROC         pfnProxyCreateGLXPixmap = NULL;
PFNPROXYDESTROYGLXPIXMAPPROC        pfnProxyDestroyGLXPixmap = NULL;
PFNPROXYQUERYEXTENSIONPROC          pfnProxyQueryExtension = NULL;
PFNPROXYQUERYVERSIONPROC            pfnProxyQueryVersion = NULL;
PFNPROXYISDIRECTPROC                pfnProxyIsDirect = NULL;
PFNPROXYGETCONFIGPROC               pfnProxyGetConfig = NULL;
PFNPROXYGETCURRENTCONTEXTPROC       pfnProxyGetCurrentContext = NULL;
PFNPROXYGETCURRENTDRAWABLEPROC      pfnProxyGetCurrentDrawable = NULL;
PFNPROXYWAITGLPROC                  pfnProxyWaitGL = NULL;
PFNPROXYWAITXPROC                   pfnProxyWaitX = NULL;
PFNPROXYUSEXFONTPROC                pfnProxyUseXFont = NULL;
PFNPROXYQUERYEXTENSIONSSTRINGPROC   pfnProxyQueryExtensionsString = NULL;
PFNPROXYQUERYSERVERSTRINGPROC       pfnProxyQueryServerString = NULL;
PFNPROXYGETCLIENTSTRINGPROC         pfnProxyGetClientString = NULL;
PFNPROXYGETCURRENTDISPLAYPROC       pfnProxyGetCurrentDisplay = NULL;
PFNPROXYCHOOSEFBCONFIGPROC          pfnProxyChooseFBConfig = NULL;
PFNPROXYGETFBCONFIGATTRIBPROC       pfnProxyGetFBConfigAttrib = NULL;
PFNPROXYGETFBCONFIGSPROC            pfnProxyGetFBConfigs = NULL;
PFNPROXYGETVISUALFROMFBCONFIGPROC   pfnProxyGetVisualFromFBConfig = NULL;
PFNPROXYCREATEWINDOWPROC            pfnProxyCreateWindow = NULL;
PFNPROXYDESTROYWINDOWPROC           pfnProxyDestroyWindow = NULL;
PFNPROXYCREATEPIXMAPPROC            pfnProxyCreatePixmap = NULL;
PFNPROXYDESTROYPIXMAPPROC           pfnProxyDestroyPixmap = NULL;
PFNPROXYCREATEPBUFFERPROC           pfnProxyCreatePBuffer = NULL;
PFNPROXYDESTROYPBUFFERPROC          pfnProxyDestroyPBuffer = NULL;
PFNPROXYQUERYDRAWABLEPROC           pfnProxyQueryDrawable = NULL;
PFNPROXYCREATENEWCONTEXTPROC        pfnProxyCreateNewContext = NULL;
PFNPROXYMAKECONTEXTCURRENTPROC      pfnProxyMakeContextCurrent = NULL;
PFNPROXYGETCURRENTREADDRAWABLEPROC  pfnProxyGetCurrentReadDrawable = NULL;
PFNPROXYQUERYCONTEXTPROC            pfnProxyQueryContext = NULL;
PFNPROXYSELECTEVENTPROC             pfnProxySelectEvent = NULL;
PFNPROXYGETSELECTEDEVENTPROC        pfnProxyGetSelectedEvent = NULL;

/* GLX extension functions */
PFNPROXYCREATECONTEXTATTRIBSARBPROC     pfnProxyCreateContextAttribsARB = NULL;
PFNPROXYSWAPINTERVALSGIPROC             pfnProxySwapIntervalSGI = NULL;
PFNPROXYGETVIDEOSYNCSGIPROC             pfnProxyGetVideoSyncSGI = NULL;
PFNPROXYWAITVIDEOSYNCSGIPROC            pfnProxyWaitVideoSyncSGI = NULL;
PFNPROXYMAKECURRENTREADSGIPROC          pfnProxyMakeCurrentReadSGI = NULL;
PFNPROXYGETCURRENTREADDRAWABLESGIPROC   pfnProxyGetCurrentReadDrawableSGI = NULL;
#ifdef _VL_H
PFNPROXYCREATEGLXVIDEOSOURCESGIXPROC    pfnProxyCreateGLXVideoSourceSGIX = NULL;
PFNPROXYDESTROYGLXVIDEOSOURCESGIXPROC   pfnProxyDestroyGLXVideoSourceSGIX = NULL;
#endif
PFNPROXYGETCURRENTDISPLAYEXTPROC        pfnProxyGetCurrentDisplayEXT = NULL;
PFNPROXYQUERYCONTEXTINFOEXTPROC         pfnProxyQueryContextInfoEXT = NULL;
PFNPROXYGETCONTEXTIDEXTPROC             pfnProxyGetContextIDEXT = NULL;
PFNPROXYIMPORTCONTEXTEXTPROC            pfnProxyImportContextEXT = NULL;
PFNPROXYFREECONTEXTEXTPROC              pfnProxyFreeContextEXT = NULL;
PFNPROXYGETFBCONFIGATTRIBSGIXPROC       pfnProxyGetFBConfigAttribSGIX = NULL;
PFNPROXYCHOOSEFBCONFIGSGIXPROC          pfnProxyChooseFBConfigSGIX = NULL;
PFNPROXYCREATEGLXPIXMAPWITHCONFIGSGIXPROC pfnProxyCreateGLXPixmapWithConfigSGIX = NULL;
PFNPROXYCREATECONTEXTWITHCONFIGSGIXPROC pfnProxyCreateContextWithConfigSGIX = NULL;
PFNPROXYGETVISUALFROMFBCONFIGSGIXPROC   pfnProxyGetVisualFromFBConfigSGIX = NULL;
PFNPROXYGETFBCONFIGFROMVISUALSGIXPROC   pfnProxyGetFBConfigFromVisualSGIX = NULL;
PFNPROXYCREATEGLXPBUFFERSGIXPROC        pfnProxyCreateGLXPbufferSGIX = NULL;
PFNPROXYDESTROYGLXPBUFFERSGIXPROC       pfnProxyDestroyGLXPbufferSGIX = NULL;
PFNPROXYQUERYGLXPBUFFERSGIXPROC         pfnProxyQueryGLXPbufferSGIX = NULL;
PFNPROXYSELECTEVENTSGIXPROC             pfnProxySelectEventSGIX = NULL;
PFNPROXYGETSELECTEDEVENTSGIXPROC        pfnProxyGetSelectedEventSGIX = NULL;
PFNPROXYCUSHIONSGIPROC                  pfnProxyCushionSGI = NULL;
PFNPROXYBINDCHANNELTOWINDOWSGIXPROC     pfnProxyBindChannelToWindowSGIX = NULL;
PFNPROXYCHANNELRECTSGIXPROC             pfnProxyChannelRectSGIX = NULL;
PFNPROXYQUERYCHANNELRECTSGIXPROC        pfnProxyQueryChannelRectSGIX = NULL;
PFNPROXYQUERYCHANNELDELTASSGIXPROC      pfnProxyQueryChannelDeltasSGIX = NULL;
PFNPROXYCHANNELRECTSYNCSGIXPROC         pfnProxyChannelRectSyncSGIX = NULL;
#ifdef _DM_BUFFER_H
PFNPROXYASSOCIATEDMPBUFFERSGIXPROC      pfnProxyAssociateDMPbufferSGIX = NULL;
#endif
PFNPROXYJOINSWAPGROUPSGIXPROC           pfnProxyJoinSwapGroupSGIX = NULL;
PFNPROXYBINDSWAPBARRIERSGIXPROC         pfnProxyBindSwapBarrierSGIX = NULL;
PFNPROXYQUERYMAXSWAPBARRIERSSGIXPROC    pfnProxyQueryMaxSwapBarriersSGIX = NULL;
PFNPROXYGETTRANSPARENTINDEXSUNPROC      pfnProxyGetTransparentIndexSUN = NULL;
PFNPROXYCOPYSUBBUFFERMESAPROC           pfnProxyCopySubBufferMESA = NULL;
PFNPROXYCREATEGLXPIXMAPMESAPROC         pfnProxyCreateGLXPixmapMESA = NULL;
PFNPROXYRELEASEBUFFERSMESAPROC          pfnProxyReleaseBuffersMESA = NULL;
PFNPROXYSET3DFXMODEMESAPROC             pfnProxySet3DfxModeMESA = NULL;
PFNPROXYGETSYNCVALUESOMLPROC            pfnProxyGetSyncValuesOML = NULL;
PFNPROXYGETMSCRATEOMLPROC               pfnProxyGetMscRateOML = NULL;
PFNPROXYSWAPBUFFERSMSCOMLPROC           pfnProxySwapBuffersMscOML = NULL;
PFNPROXYWAITFORMSCOMLPROC               pfnProxyWaitForMscOML = NULL;
PFNPROXYWAITFORSBCOMLPROC               pfnProxyWaitForSbcOML = NULL;
PFNPROXYQUERYHYPERPIPENETWORKSGIXPROC   pfnProxyQueryHyperpipeNetworkSGIX = NULL;
PFNPROXYHYPERPIPECONFIGSGIXPROC         pfnProxyHyperpipeConfigSGIX = NULL;
PFNPROXYQUERYHYPERPIPECONFIGSGIXPROC    pfnProxyQueryHyperpipeConfigSGIX = NULL;
PFNPROXYDESTROYHYPERPIPECONFIGSGIXPROC  pfnProxyDestroyHyperpipeConfigSGIX = NULL;
PFNPROXYBINDHYPERPIPESGIXPROC           pfnProxyBindHyperpipeSGIX = NULL;
PFNPROXYQUERYHYPERPIPEBESTATTRIBSGIXPROC pfnProxyQueryHyperpipeBestAttribSGIX = NULL;
PFNPROXYHYPERPIPEATTRIBSGIXPROC         pfnProxyHyperpipeAttribSGIX = NULL;
PFNPROXYQUERYHYPERPIPEATTRIBSGIXPROC    pfnProxyQueryHyperpipeAttribSGIX = NULL;
PFNPROXYGETAGPOFFSETMESAPROC            pfnProxyGetAGPOffsetMESA = NULL;
PFNPROXYBINDTEXIMAGEEXTPROC             pfnProxyBindTexImageEXT = NULL;
PFNPROXYRELEASETEXIMAGEEXTPROC          pfnProxyReleaseTexImageEXT = NULL;
PFNPROXYENUMERATEVIDEODEVICESNVPROC     pfnProxyEnumerateVideoDevicesNV = NULL;
PFNPROXYBINDVIDEODEVICENVPROC           pfnProxyBindVideoDeviceNV = NULL;
PFNPROXYGETVIDEODEVICENVPROC            pfnProxyGetVideoDeviceNV = NULL;
PFNPROXYRELEASEVIDEODEVICENVPROC        pfnProxyReleaseVideoDeviceNV = NULL;
PFNPROXYBINDVIDEOIMAGENVPROC            pfnProxyBindVideoImageNV = NULL;
PFNPROXYRELEASEVIDEOIMAGENVPROC         pfnProxyReleaseVideoImageNV = NULL;
PFNPROXYSENDPBUFFERTOVIDEONVPROC        pfnProxySendPbufferToVideoNV = NULL;
PFNPROXYGETVIDEOINFONVPROC              pfnProxyGetVideoInfoNV = NULL;
PFNPROXYJOINSWAPGROUPNVPROC             pfnProxyJoinSwapGroupNV = NULL;
PFNPROXYBINDSWAPBARRIERNVPROC           pfnProxyBindSwapBarrierNV = NULL;
PFNPROXYQUERYSWAPGROUPNVPROC            pfnProxyQuerySwapGroupNV = NULL;
PFNPROXYQUERYMAXSWAPGROUPSNVPROC        pfnProxyQueryMaxSwapGroupsNV = NULL;
PFNPROXYQUERYFRAMECOUNTNVPROC           pfnProxyQueryFrameCountNV = NULL;
PFNPROXYRESETFRAMECOUNTNVPROC           pfnProxyResetFrameCountNV = NULL;
PFNPROXYBINDVIDEOCAPTUREDEVICENVPROC    pfnProxyBindVideoCaptureDeviceNV = NULL;
PFNPROXYENUMERATEVIDEOCAPTUREDEVICESNVPROC pfnProxyEnumerateVideoCaptureDevicesNV = NULL;
PFNPROXYLOCKVIDEOCAPTUREDEVICENVPROC    pfnProxyLockVideoCaptureDeviceNV = NULL;
PFNPROXYQUERYVIDEOCAPTUREDEVICENVPROC   pfnProxyQueryVideoCaptureDeviceNV = NULL;
PFNPROXYRELEASEVIDEOCAPTUREDEVICENVPROC pfnProxyReleaseVideoCaptureDeviceNV = NULL;
PFNPROXYSWAPINTERVALEXTPROC             pfnProxySwapIntervalEXT = NULL;
PFNPROXYCOPYIMAGESUBDATANVPROC          pfnProxyCopyImageSubDataNV = NULL;

extern void *glProxyGetProcAddr(void *handle, const char *name);
extern void *glProxyGetExtProcAddr(void *handle, const char *name);

int glxProxyInit(void *handle)
{
	if (NULL == handle) {
                return -1;
        }

        pfnProxyChooseVisual = glProxyGetProcAddr(handle, "glXChooseVisual");
        pfnProxyCreateContext = glProxyGetProcAddr(handle, "glXCreateContext");
        pfnProxyDestroyContext = glProxyGetProcAddr(handle, "glXDestroyContext");
        pfnProxyMakeCurrent = glProxyGetProcAddr(handle, "glXMakeCurrent");
        pfnProxyCopyContext = glProxyGetProcAddr(handle, "glXCopyContext");
        pfnProxySwapBuffers = glProxyGetProcAddr(handle, "glXSwapBuffers");
        pfnProxyCreateGLXPixmap = glProxyGetProcAddr(handle, "glXCreateGLXPixmap");
        pfnProxyDestroyGLXPixmap = glProxyGetProcAddr(handle, "glXDestroyGLXPixmap");
        pfnProxyQueryExtension = glProxyGetProcAddr(handle, "glXQueryExtension");
        pfnProxyQueryVersion = glProxyGetProcAddr(handle, "glXQueryVersion");
        pfnProxyIsDirect = glProxyGetProcAddr(handle, "glXIsDirect");
        pfnProxyGetConfig = glProxyGetProcAddr(handle, "glXGetConfig");
        pfnProxyGetCurrentContext = glProxyGetProcAddr(handle, "glXGetCurrentContext");
        pfnProxyGetCurrentDrawable = glProxyGetProcAddr(handle, "glXGetCurrentDrawable");
        pfnProxyWaitGL = glProxyGetProcAddr(handle, "glXWaitGL");
        pfnProxyWaitX = glProxyGetProcAddr(handle, "glXWaitX");     
        pfnProxyUseXFont = glProxyGetProcAddr(handle, "glXUseXFont");
        pfnProxyQueryExtensionsString = glProxyGetProcAddr(handle, "glXQueryExtensionsString");
        pfnProxyQueryServerString = glProxyGetProcAddr(handle, "glXQueryServerString");
        pfnProxyGetClientString = glProxyGetProcAddr(handle, "glXGetClientString");
        pfnProxyGetCurrentDisplay = glProxyGetProcAddr(handle, "glXGetCurrentDisplay");
        pfnProxyChooseFBConfig = glProxyGetProcAddr(handle, "glXChooseFBConfig");
        pfnProxyGetFBConfigAttrib = glProxyGetProcAddr(handle, "glXGetFBConfigAttrib");
        pfnProxyGetFBConfigs = glProxyGetProcAddr(handle, "glXGetFBConfigs");
        pfnProxyGetVisualFromFBConfig = glProxyGetProcAddr(handle, "glXGetVisualFromFBConfig");
        pfnProxyCreateWindow = glProxyGetProcAddr(handle, "glXCreateWindow");
        pfnProxyDestroyWindow = glProxyGetProcAddr(handle, "glXDestroyWindow");
        pfnProxyCreatePixmap = glProxyGetProcAddr(handle, "glXCreatePixmap");
        pfnProxyDestroyPixmap = glProxyGetProcAddr(handle, "glXDestroyPixmap");
        pfnProxyCreatePBuffer = glProxyGetProcAddr(handle, "glXCreatePBuffer");
        pfnProxyDestroyPBuffer = glProxyGetProcAddr(handle, "glXDestroyPBuffer");
        pfnProxyQueryDrawable = glProxyGetProcAddr(handle, "glXQueryDrawable");
        pfnProxyCreateNewContext = glProxyGetProcAddr(handle, "glXCreateNewContext");
        pfnProxyMakeContextCurrent = glProxyGetProcAddr(handle, "glXMakeContextCurrent");
        pfnProxyGetCurrentReadDrawable = glProxyGetProcAddr(handle, "glXGetCurrentReadDrawable");
        pfnProxyQueryContext = glProxyGetProcAddr(handle, "glXQueryContext");
        pfnProxySelectEvent = glProxyGetProcAddr(handle, "glXSelectEvent");
        pfnProxyGetSelectedEvent = glProxyGetProcAddr(handle, "glXGetSelectecEvent");

	return 0;
}

int glxProxyExtInit(void *handle)
{
	if (NULL == handle) {
                return -1;
        }

	pfnProxyCreateContextAttribsARB = glProxyGetExtProcAddr(handle, "glXCreateContextAttribsARB");
	pfnProxySwapIntervalSGI = glProxyGetExtProcAddr(handle, "glXSwapIntervalSGI");
	pfnProxyGetVideoSyncSGI = glProxyGetExtProcAddr(handle, "glXGetVideoSyncSGI");
	pfnProxyWaitVideoSyncSGI = glProxyGetExtProcAddr(handle, "glXWaitVideoSyncSGI");
	pfnProxyMakeCurrentReadSGI = glProxyGetExtProcAddr(handle, "glXMakeCurrentReadSGI");
	pfnProxyGetCurrentReadDrawableSGI = glProxyGetExtProcAddr(handle, "glXGetCurrentReadDrawableSGI");
#ifdef _VL_H
	pfnProxyCreateGLXVideoSourceSGIX = glProxyGetExtProcAddr(handle, "glXCreateGLXVideoSourceSGIX");
	pfnProxyDestroyGLXVideoSourceSGIX = glProxyGetExtProcAddr(handle, "glXDestroyGLXVideoSourceSGIX");
#endif
	pfnProxyGetCurrentDisplayEXT = glProxyGetExtProcAddr(handle, "glXGetCurrentDisplayEXT");
	pfnProxyQueryContextInfoEXT = glProxyGetExtProcAddr(handle, "glXQueryContextInfoEXT");
	pfnProxyGetContextIDEXT = glProxyGetExtProcAddr(handle, "glXGetContextIDEXT");
	pfnProxyImportContextEXT = glProxyGetExtProcAddr(handle, "glXImportContextEXT");
	pfnProxyFreeContextEXT = glProxyGetExtProcAddr(handle, "glXFreeContextEXT");
	pfnProxyGetFBConfigAttribSGIX = glProxyGetExtProcAddr(handle, "glXGetFBConfigAttribSGIX");
	pfnProxyChooseFBConfigSGIX = glProxyGetExtProcAddr(handle, "glXChooseFBConfigSGIX");
	pfnProxyCreateGLXPixmapWithConfigSGIX = glProxyGetExtProcAddr(handle, "glXCreateGLXPixmapWithConfigSGIX");
	pfnProxyCreateContextWithConfigSGIX = glProxyGetExtProcAddr(handle, "glXCreateContextWithConfigSGIX");
	pfnProxyGetVisualFromFBConfigSGIX = glProxyGetExtProcAddr(handle, "glXGetVisualFromFBConfigSGIX");
	pfnProxyGetFBConfigFromVisualSGIX = glProxyGetExtProcAddr(handle, "glXGetFBConfigFromVisualSGIX");
	pfnProxyCreateGLXPbufferSGIX = glProxyGetExtProcAddr(handle, "glXCreateGLXPbufferSGIX");
	pfnProxyDestroyGLXPbufferSGIX = glProxyGetExtProcAddr(handle, "glXDestroyGLXPbufferSGIX");
	pfnProxyQueryGLXPbufferSGIX = glProxyGetExtProcAddr(handle, "glXQueryGLXPbufferSGIX");
	pfnProxySelectEventSGIX = glProxyGetExtProcAddr(handle, "glXSelectEventSGIX");
	pfnProxyGetSelectedEventSGIX = glProxyGetExtProcAddr(handle, "glXGetSelectedEventSGIX");
	pfnProxyCushionSGI = glProxyGetExtProcAddr(handle, "glXCushionSGI");
	pfnProxyBindChannelToWindowSGIX = glProxyGetExtProcAddr(handle, "glXBindChannelToWindowSGIX");
	pfnProxyChannelRectSGIX = glProxyGetExtProcAddr(handle, "glXChannelRectSGIX");
	pfnProxyQueryChannelRectSGIX = glProxyGetExtProcAddr(handle, "glXQueryChannelRectSGIX");
	pfnProxyQueryChannelDeltasSGIX = glProxyGetExtProcAddr(handle, "glXQueryChannelDeltasSGIX");
	pfnProxyChannelRectSyncSGIX = glProxyGetExtProcAddr(handle, "glXChannelRectSyncSGIX");
#ifdef _DM_BUFFER_H
	pfnProxyAssociateDMPbufferSGIX = glProxyGetExtProcAddr(handle, "glXAssociateDMPbufferSGIX");
#endif
	pfnProxyJoinSwapGroupSGIX = glProxyGetExtProcAddr(handle, "glXJoinSwapGroupSGIX");
	pfnProxyBindSwapBarrierSGIX = glProxyGetExtProcAddr(handle, "glXBindSwapBarrierSGIX");
	pfnProxyQueryMaxSwapBarriersSGIX = glProxyGetExtProcAddr(handle, "glXQueryMaxSwapBarriersSGIX");
	pfnProxyGetTransparentIndexSUN = glProxyGetExtProcAddr(handle, "glXGetTransparentIndexSUN");
	pfnProxyCopySubBufferMESA = glProxyGetExtProcAddr(handle, "glXCopySubBufferMESA");
	pfnProxyCreateGLXPixmapMESA = glProxyGetExtProcAddr(handle, "glXCreateGLXPixmapMESA");
	pfnProxyReleaseBuffersMESA = glProxyGetExtProcAddr(handle, "glXReleaseBuffersMESA");
	pfnProxySet3DfxModeMESA = glProxyGetExtProcAddr(handle, "glXSet3DfxModeMESA");
	pfnProxyGetSyncValuesOML = glProxyGetExtProcAddr(handle, "glXGetSyncValuesOML");
	pfnProxyGetMscRateOML = glProxyGetExtProcAddr(handle, "glXGetMscRateOML");
	pfnProxySwapBuffersMscOML = glProxyGetExtProcAddr(handle, "glXSwapBuffersMscOML");
	pfnProxyWaitForMscOML = glProxyGetExtProcAddr(handle, "glXWaitForMscOML");
	pfnProxyWaitForSbcOML = glProxyGetExtProcAddr(handle, "glXWaitForSbcOML");
	pfnProxyQueryHyperpipeNetworkSGIX = glProxyGetExtProcAddr(handle, "glXQueryHyperpipeNetworkSGIX");
	pfnProxyHyperpipeConfigSGIX = glProxyGetExtProcAddr(handle, "glXHyperpipeConfigSGIX");
	pfnProxyQueryHyperpipeConfigSGIX = glProxyGetExtProcAddr(handle, "glXQueryHyperpipeConfigSGIX");
	pfnProxyDestroyHyperpipeConfigSGIX = glProxyGetExtProcAddr(handle, "glXDestroyHyperpipeConfigSGIX");
	pfnProxyBindHyperpipeSGIX = glProxyGetExtProcAddr(handle, "glXBindHyperpipeSGIX");
	pfnProxyQueryHyperpipeBestAttribSGIX = glProxyGetExtProcAddr(handle, "glXQueryHyperpipeBestAttribSGIX");
	pfnProxyHyperpipeAttribSGIX = glProxyGetExtProcAddr(handle, "glXHyperpipeAttribSGIX");
	pfnProxyQueryHyperpipeAttribSGIX = glProxyGetExtProcAddr(handle, "glXQueryHyperpipeAttribSGIX");
	pfnProxyGetAGPOffsetMESA = glProxyGetExtProcAddr(handle, "glXGetAGPOffsetMESA");
	pfnProxyBindTexImageEXT = glProxyGetExtProcAddr(handle, "glXBindTexImageEXT");
	pfnProxyReleaseTexImageEXT = glProxyGetExtProcAddr(handle, "glXReleaseTexImageEXT");
	pfnProxyEnumerateVideoDevicesNV = glProxyGetExtProcAddr(handle, "glXEnumerateVideoDevicesNV");
	pfnProxyBindVideoDeviceNV = glProxyGetExtProcAddr(handle, "glXBindVideoDeviceNV");
	pfnProxyGetVideoDeviceNV = glProxyGetExtProcAddr(handle, "glXGetVideoDeviceNV");
	pfnProxyReleaseVideoDeviceNV = glProxyGetExtProcAddr(handle, "glXReleaseVideoDeviceNV");
	pfnProxyBindVideoImageNV = glProxyGetExtProcAddr(handle, "glXBindVideoImageNV");
	pfnProxyReleaseVideoImageNV = glProxyGetExtProcAddr(handle, "glXReleaseVideoImageNV");
	pfnProxySendPbufferToVideoNV = glProxyGetExtProcAddr(handle, "glXSendPbufferToVideoNV");
	pfnProxyGetVideoInfoNV = glProxyGetExtProcAddr(handle, "glXGetVideoInfoNV");
	pfnProxyJoinSwapGroupNV = glProxyGetExtProcAddr(handle, "glXJoinSwapGroupNV");
	pfnProxyBindSwapBarrierNV = glProxyGetExtProcAddr(handle, "glXBindSwapBarrierNV");
	pfnProxyQuerySwapGroupNV = glProxyGetExtProcAddr(handle, "glXQuerySwapGroupNV");
	pfnProxyQueryMaxSwapGroupsNV = glProxyGetExtProcAddr(handle, "glXQueryMaxSwapGroupsNV");
	pfnProxyQueryFrameCountNV = glProxyGetExtProcAddr(handle, "glXQueryFrameCountNV");
	pfnProxyResetFrameCountNV = glProxyGetExtProcAddr(handle, "glXResetFrameCountNV");
	pfnProxyBindVideoCaptureDeviceNV = glProxyGetExtProcAddr(handle, "glXBindVideoCaptureDeviceNV");
	pfnProxyEnumerateVideoCaptureDevicesNV = glProxyGetExtProcAddr(handle, "glXEnumerateVideoCaptureDevicesNV");
	pfnProxyLockVideoCaptureDeviceNV = glProxyGetExtProcAddr(handle, "glXLockVideoCaptureDeviceNV");
	pfnProxyQueryVideoCaptureDeviceNV = glProxyGetExtProcAddr(handle, "glXQueryVideoCaptureDeviceNV");
	pfnProxyReleaseVideoCaptureDeviceNV = glProxyGetExtProcAddr(handle, "glXReleaseVideoCaptureDeviceNV");
	pfnProxySwapIntervalEXT = glProxyGetExtProcAddr(handle, "glXSwapIntervalEXT");
	pfnProxyCopyImageSubDataNV = glProxyGetExtProcAddr(handle, "glXCopyImageSubDataNV");

	return 0;
}	
